2001-12-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile: More i386-linux support.

2001-12-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.00 released.

2001-12-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile: Support i386-linux.
	* common.h: Ditto.

2001-11-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* rootdens_G_P.C (Rootdens_G_P): Made it a struct.

	* rootdens_G_P.C, rootdens.h (set_density): Take DS argument.
	* root_system.C (full_grown, tick, full_grown): Update callers.
	* root_system.C, root_system.h (tick, full_grown): Take DS arguments.
	* crop_std.C (initialize, tick): Update callers.
	* crop_simple.C (tick): Ditto.

2001-11-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* rootdens.C, rootdens.h (density_distribution_parameter): Moved
	from here.
	* rootdens_G_P.C (density_distribution_parameter): To here.

2001-11-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.99 released.

2001-11-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* harvesting.C (load_syntax): Make 'cut_delay' take absolute value.
	(operator): Update caller.

	* development.C (tick_daily): Support `cut_stress'.
	* crop_std.C (tick): Update caller.

	* canopy_std.C (CropHeight): Obey 'HvsWStem'.

	* lib/grass2.dai, lib/maize.dai, lib/pea.dai, lib/rye.dai,
	lib/sbarley.dai, lib/srape.dai, lib/sugarbeet.dai, lib/swheat.dai,
	lib/wbarley.dai, lib/wrape.dai, lib/wwheat.dai: Fix LAIDist.

2001-11-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Root Density"): New log model.

	* rootdens_G_P.C (set_density): Support MinDens.

	* root_system.C (load_syntax): Added checks.
	* rootdens_G_P.C (Rootdens_G_PSyntax): Added checks.

	* Version 1.98 released.

2001-11-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.C (check): Add numeric checks.

	* check_range.C, check_range.h:  Renamed from check_std.
	* Makefile (OTHER, REMOVE): Ditto.

2001-11-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.C, syntax.h (non_negative, non_positive, check): Removed.

	* check_std.h, check_std.C (NonPositive, Negative, Positive,
	RangeII, RangeIE, RangeEI, RangeEE, Below, BelowOrEqual, Above,
	AboveOrEqual): New classes. 
	* am.C (AM_Syntax): Use them.
	* adsorption_langmuir.C (AdsorptionLangmuirSyntax): Use them.
	* adsorption_freundlich.C (AdsorptionFreundlichSyntax): Use them.
	* action_tillage.C (ActionSetPorositySyntax): Use them.
	* action_surface.C (ActionSurfaceSyntax): Use them.
	* action_spray.C (ActionSpraySyntax): Use them.
	* action_irrigate.C (load_syntax): Use them.
	* action_heat.C (ActionHeatSyntax): Use them.
	* action_crop.C (check_alist): Use them.
	* crop_simple.C (CropSimpleSyntax): Use them.
	* om.C (load_syntax): Use them.
	* hydraulic_M_C.C (HydraulicM_CSyntax): Use it.
	* hydraulic_B_C.C (HydraulicB_CSyntax): Use it.
	* hydraulic.C (load_syntax): Use them.

2001-11-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.97 released.

2001-11-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* check.C, check.h, check_std.C, check_std.h: New utility.
	* Makefile (OTHER): Add them.
	* syntax.C, syntax.h (check, add): Support them.
	* parser_file.C (load_list): Call new syntax check.
	
	* main.C (main): Accept string exceptions.

	* syntax.h, syntax.C (is_fraction): Removed.
	* all: Fixed callers.

	* syntax.h (add_submodule): Removed template.
	* all: Fixed callers.

2001-11-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.C, syntax.h (add_submodule_sequence): New member
	function. 
	* syntax.h (add_submodule_sequence):  Removed template.
x	* vegetation_permanent.C (VegetationPermanentSyntax): Don't use
	`add_submodule_sequence'. 
	* organic_matter.C (load_syntax): Ditto.
	* crop_sold.C (CropSoldSyntax): Ditto.
	* crop_old.C (CropOldSyntax): Ditto.
	* crop_simple.C (CropSimpleSyntax): Ditto.
	* bioincorporation.C (load_syntax): Ditto.

	* organic_matter.C (Buffer::tick): Remove bogus assertion.

	* Version 1.96 released.

2001-11-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (Buffer::tick): Max rate is 1.0.

	* lib/log.dai ("Crop Production"): Log `cut_stress'.
	* crop_std.C (tick): Use `cut_stress'.
	* harvesting.C (operator): Set `production_delay' and `last_cut'.

2001-11-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* harvesting.h, harvesting.C (last_cut): New state variable.
	(production_delay): New state variable.
	(cut_delay): New parameter.
	(cut_stress): New log variable.
	(tick): New member function.
	
2001-11-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.95 released.

2001-11-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (harvest): Moved most to `harvesting.C'.
	* harvesting.C, harvesting.h (operator()): New function.

	* organic_matter.C (Buffer::tick): Don't apply negative rate.

	* harvesting.C (load_syntax): Removed duplicate definition of
	"Stem" syntax. 

	* organic_matter.C (tick): Added debug information.

	* mactrans_std.C (tick): Changed assertion to warning.

2001-11-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.94 released.

2001-11-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crpaux.C, crpaux.h: Removed submodel.
	* Makefile (SUBMODELS): Removed.
	(REMOVE): Added it here.
	* production.C, production.h: Merged it here.
	* lib/log.dai: Updated.

	* Version 1.93 released.

2001-11-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C, photosynthesis.C, photosynthesis.h, production.C,
	production.h, crpaux.C, crpaux.h:  Moved code to submodel. 

	* Version 1.92 released.

2001-11-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("N Balance"): Fixated moved to CrpN.
	("Crop Production"): AccFixated moved to CrpN.

	* photosynthesis.C, photosynthesis.h: New submodel.
	* vernalization.C, vernalization.h: New submodel.
	* crpn.C, crpn.h: New submodel.
	* Makefile (SUBMODELS): Add them.
	* crop_std.C: Use them.

	* partition.C, partition.h: New submodel.
	* Makefile (SUBMODELS): Add it.
	* crop_std.C: Use it.

	* lib/log.dai ("N Balance"): Added fixation.

2001-11-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crpaux.C, crpaux.h: New submodel.
	* Makefile (SUBMODELS): Add it.
	* crop_std.C: Use it.

	* development.C, development.h: New submodel.
	* Makefile (SUBMODELS): Added it.
	* crop_std.C: Use it.
	* lib/log.dai ("Crop Production"): Update.

	* production.C, production.h: New submodel.
	* Makefile (SUBMODELS): Added it.
	* crop_std.C: Use it.

	* lib/fertilizer.dai: Added provider information.

	* harvesting.C, harvesting.h: New submodel.
	* Makefile (SUBMODELS): Added it.
	* crop_std.C: Use it.

	* root_system.h: Added include guard.

2001-11-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.91 released.

2001-11-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/fertilizer.dai: Added descriptions.
	(NPK): Removed.
	* am.C (AM_Syntax): Added `description' to organic and mineral
	fertilizer types.

	* rootdens_G_P.C (Rootdens_G_PSyntax): Added missing "\n\".

	* Version 1.90 released.

2001-11-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.h, weather.C (deposit, tick_after): Made deposit logable.
	* lib/log.dai ("N Balance"): Log it.

2001-11-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* rootdens_G_P.C: Renamed from `rootdens_std.C'.
	* Makefile (REMOVE, MODELS): Updated.

	* om.C, m.h (get_initial_C_per_N): Made it a static member.
	* am.C (check_root): Use it.

2001-10-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.89 released.

2001-10-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* rootdens.C, rootdens.h: New component.
	* Makefile (COMPONENTS): Add it.
	* rootdens_std.C: New model.
	* Makefile (MODELS): Add it.
	* root_system.C, root_system.h: Use them.
	* lib/maize.dai, lib/rye.dai, lib/sbarley.dai, lib/sugarbeet.dai,
	lib/fodderbeet.dai, lib/srape.dai, lib/swheat.dai,
	lib/wbarley.dai, lib/wbarley.dai, lib/wrape.dai, lib/wwheat.dai,
	lib/grass.dai:  Remove old root density parameters.

	* lib/log.dai ("Fertilizer"): Removed Seed_N.

2001-10-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.88 released.

2001-10-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("N Balance"): Log harvest N.
	("Carbon Balance"): Log harvest C.

	* harvest.C, harvest.h (total_N, total_C, total_DM): New
	functions.
	* vegetation_crops.C, vegetation_permanent.C, vegetation.h
	(harvest):  New harvest_DM, harvest_N and harvest_C parameters. 
	* column_base.C (harvest): Update caller.
	* column_base.C, column_base.h (tick_base): New function.
	* column_std.C, column_inorganic.C (tick): Call it.
	* column_base.C, column_base.h (harvest_DM, harvest_N, harvest_C):
	New log variables.

	* Version 1.87 released.

2001-10-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai: Merged SH changes.

2001-10-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_sold.C, crop_old.C, crop_std.C, crop_simple.C, crop.h
	(total_N): New function.
	* vegetation.h, vegetation_crops.C, vegetation_permanent.C (sow):
	Return amount of N in seed.
	* column_std.C (seed_N): New log variable.
	* lib/log.dai ("Fertilizer"): Log seed N.
	
	* crop_std.C (CrpNPar::check_alist): New function.
	(CropStandardSyntax): Use it.
	(SeedN): Make it optional.
	* parser_file.C, lexer.C, lexer.h (warning): New function.
	* parser_file.C (load_list): Use it.

	* lib/sbarley.dai, lib/grass.dai, fodderbeet.dai, lib/grass2.dai,
	lib/maize.dai, lib/pea.dai, lib/rye.dai, lib/srape.dai,
	lib/sugarbeet.dai, lib/swheat.dai, lib/wbarley.dai, lib/wrape.dai,
	lib/wwheat.dai: Use "Prod CropN" instead of "CrpN SeedN". 

2001-10-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.86 released.

2001-10-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Crop Photosynthesis"): Fix CO2-C to CO2 factor.

	* am.h, am.C (default_root): New function.
	(initialize, create): Take soil instead of geometry argument.
	* organic_matter.C (load_syntax): Use it.
	* am.C (AM_Syntax): Add default values for "root", and a new
	"total_N_fraction". 
	(initialize, check_root): Use it.

	* organic_matter.C (initialize): Count input from AM pools when
	initializing SMB.
	* organic_matter.C (load_syntax): Document initialization of SMB.

2001-10-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.85 released.

2001-10-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* printer.h, printer_file.h, printer_file.C (print_entry): New
	member function.

	* log_checkpoint.C (done): Use it.

	* path.h, path.C: New utility.
	* options.h, option.C, common.h: Use it.
	* lexer.h, lexer.C: Use it.
	* daisy.C (load_syntax): Add "path" and "directory".
	* parser_file.C (load_list): Use it.

2001-10-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_harvest.C (LogHarvest): Added missing backslash.

2001-10-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.84 released.

2001-10-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* macro_std.C (tick): Handle fully saturated soil.

2001-10-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* COPYING, COPYING.LIB: New files.
	* Makefile (TEXT): Added them.
	* all: Added copyright notices.

2001-10-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.83 released.

2001-10-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* common.h: Distinguish between Borland C++ 5.0 and 5.5.
	* lexer.h, lexer.C: Ditto.
	* options.C: [__BORLANDC__] Include <dir.h> here.

	* crop_std.C (harvest): Log economic yield for C.

2001-10-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.82 released.

2001-10-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_simple.C, crop_std.C, crop_old.C, crop_sold.C (harvest):
	Update callers. 

	* log_harvest.C (match): Use it.

	* harvest.C, harvest.h (stem_C, dead_C, leaf_C, sorg_C): New members.

2001-10-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.80 released.

2001-10-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (add): Always add both C and N, never rely on a fixed C/N
	ratio. 
	(add): Simplified assertions.

	* mactrans_std.C (tick): Handle upstream macropores.

2001-09-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* depend.C (object_desc): Fixed call by value strings.

2001-09-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: CVS synched with Cygwin and Borland versions.

2001-09-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.79 released.

2001-09-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pet.C (load_syntax): Added 'reference_evaporation' log variable. 
	* pet_weather.C, pet_makkink.C, pet_PM.C (output): Log it.
	* lib/log.dai ("Weather", "Bioclimate"): Use it.

2001-07-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (tick): Make sure we calculate the last root
	node, even when 'active_underground' is false (fixed off-by-one
	error). 

2001-07-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.78 released.

2001-07-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/grass.dai ("Grass to grain"): Removed obsolete parameters. 

	* crop_std.C: SH: Keep track of C in crop.

	* Version 1.77 released.

2001-07-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzrichard.C (richard): Check for darcy == 0.0.

	* all: Ported to GCC 3.0.
	
2001-06-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* message.C, message.h: Split from common.C.
	* Makefile (OTHER): Added it.

2001-06-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* svat_pmsw.C (RSCSTAR): Use fabs, not abs.

2001-06-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_std.C (data_description): Unconst to make GCC 3.0 happy.
	(keyword_description): Ditto.

	* action_activity.C (ActionActivity::check): Remove const
	* action_lisp.C (struct ActionProgn::check): Ditto.
	* action_with.C (ActionWithColumn::check): Ditto.

	* mathlib.C (set_exceptions): Declare varargs.

2001-05-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* root_system.C (get_PotRtDpt): Workaround for Borland.

	* Version 1.76 released.

2001-05-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* root_system.C (RootSystem::RootSystem): Let `PotRtDpt' default
	to `Depth'.

	* crop_std.C (initialize): More support for planting.

	* action_with.C (output): New member function.

2001-05-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.75 released.

2001-05-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation.h, vegetation_crops.C, vegetation_permanent.C (sow):
	Ditto. 

	* vegetation_permanent.C, vegetation_crops.C, crop.C, crop_old.C,
	vegetation.h, crop.h, crop_std.C (initialize): Support planting.

2001-05-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioincorporation.C (speed): New member variable.
	(tick): Update it.
	(output): Log it.

2001-05-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.74 released.

2001-05-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* solute.C (tick): Less debug output.

	* select_flux_bottom.C (output_array): Use interval_border + 1.

	* condition.h, condition.C, condition_time.C (timestep): New
	member function.
	* select.h, select.C, select_flux_bottom.C, select_flux_top.C,
	select_interval.C (initialize): New `timestep' parameter. 
	Made `conv' a reference. 
	* log_select.C (LogSelect): Use them.
	* lib/log.dai: Use it.
	("Fertilizer Yearly"): Use crop seasons instead of calendar years.

2001-04-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.73 released.

2001-04-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_std.C, column_inorganic.C (tick): Don't clear variables
	here. 
	* column.h, column_base.C, column_std.C (tick): Do it here.
	* field.C, field.h (clear): Call it.
	* daisy.C (tick_logs): Call it.

2001-04-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.72 released.

2001-04-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* canopy_std.C (load_syntax): Fix dimensions.

	* crop_std.C (harvest): Fixed WBal and NBal declarations.

	* action_fertilize.C (doIt): Fix dimension in output message.

	* lib/log.dai ("Fertilizer"): Fixed dimension for 

	* horizon.C (load_syntax): Fixed description for `SOM_fractions'.
	Reported by Anders Pedersen.

2001-02-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.71 released.

2001-02-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* svat_pmsw.C (SVAT_PMSWSyntax): Fixed more log variable names.

2001-02-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.70 released.

2001-02-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* svat_pmsw.C (SVAT_PMSWSyntax): Fixed log variable names.

2001-01-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* common.h: Nogle Visual C++ 6.0 hacks.

2001-01-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.69 released.

2001-01-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* net_radiation.C, net_radiation.h (tick): Removed extra tick.

2000-12-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.68 released.

2000-12-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (get_volatilization): New function.
	* column_std.C: Support it.
	* lib/log.dai ("Fertilizer"): Added it.

2000-12-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.67 released.

2000-12-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (get_NH4): Also respect volatilization for organiz
	fertilizer. 

2000-11-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Change `quotation' to 'quotation'.

2000-11-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* alist.C, alist.h, common.C, common.h, depend.C, depend.h,
	document.C, document.h, document_LaTeX.C, lexer.C, lexer.h,
	lexer_data.C, lexer_data.h, librarian.C, librarian.h, library.C,
	library.h, mathlib.C, mathlib.h, nrutil.C, nrutil.h, options.h,
	parser.C, parser.h, parser_file.C, parser_file.h, plf.C, plf.h,
	printer.C, printer.h, printer_file.C, printer_file.h, submodel.C,
	submodel.h, syntax.C, syntax.h, time.C, time.h, tmpstream.C,
	tmpstream.h, traverse.C, traverse.h, traverse_delete.C,
	traverse_delete.h, treelog.C, treelog.h, treelog_stream.C,
	treelog_stream.h: Visual C++ 6.0 support.

2000-11-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.66 released.

2000-11-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C, groundwater_file.C, groundwater.C,
	groundwater.h (initialize): Use treelog.
	* column_base.C (initialize): Update caller.
	* groundwater_file.C:  Use lexer.
	
	* common.h (DebugMessages): Renamed from `Options'.
	* options.C, options.h: New files.
	* Makefile (OTHER): Added them.
	* cdaisy.C, column.h, column_base.C, column_base.h, column_std.C,
	common.C, common.h, daisy.C, daisy.h, field.C, field.h, lexer.C,
	lexer.h, lexer_data.C, lexer_data.h, main.C, parser.h,
	parser_file.C, parser_file.h, treelog_stream.C, weather.C,
	weather.h, weather_std.C:  Updated.
	* Makefile (DISABLED): New macro.
	More Visual C++ support.
	
2000-11-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* common.h: Some Visual C++ support.

2000-11-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.65 released.

2000-11-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all (check): Use Treelog instead of ostream for errors.

	* Version 1.64 released.

2000-11-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* depend.C depend.h document.C document.h lexer.h lexer_data.h
	parser.C parser_file.C printer.C printer_file.C submodel.C
	submodel.h traverse.C traverse.h traverse_delete.C
	traverse_delete.h: Removed Daisy references.

	* document_LaTeX.C (DocumentLaTeXSyntax): Fix type in string.

2000-11-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* daisy.C (load_syntax): Remove call to `Library::load_syntax'. 

2000-11-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* mactrans_std.C (tick): Fixed some numeric problems.

2000-11-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (snow.o): Remove special rule.

	* common.C: Removed `MINGW' ctype defs.

	* weather_simple.C: Include `mathlib.h' for `M_PI'.

	* Makefile (DYNSEARCH): New macro.
	(LINK): Use it.
	(USE_DYNLIB): New macro.
	(daisy${EXT}): Use it.

2000-11-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.63 released.

2000-11-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C: Don't include "log.h".

2000-11-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* mathlib.h (M_LN2, M_PI, M_PI_2): Define if undefined.
	(min, max): Define for Visual C++ 6.0.

	* time.C, time.h (operator=): Made it a member instead of a friend.
	(operator!=): Ditto.
	(operator<): Ditto.
	(operator<=): Ditto.
	(operator>=): Ditto.
	(operator>): Ditto.

	* librarian.h (map_create): Make it a function.
	(map_create_const): Ditto.
	(map_construct): Ditto.
	(map_construct_const): Ditto.

	* all: Comment out text after `#endif'.

	* treelog_stream.h: Use common.h to get ostream.
	* tmpstream.h: Ditto.
	* document.h: Removed forward declaration of ostream.

2000-10-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.62 released.

2000-10-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (Implementation): Dumb down `tillage_age'
	initializaer for BCC5.01

	* qmain_item.C (AListItem::recreate_item): That the new entry is a
	submodel doesn't imply the old entry was a submodel as well.

	* qmain_edit.h, qmain_edit.C (EditObject): Removed `Edit' button.

	* alist.C (remove): Allow removing non-existing entries (a no-op).

2000-10-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* qmain_item.C (AtomItem::set_selected): Valueless objects can
	also be atoms. 

	* qmain_item.C (SequenceItem::edit_delete): Implement.
	* qmain_tree.C (MainTree::edit_delete): Handle SequenceItems

	* qmain_item.C, qmain_item.h  (AtomItem::insert_before): New function.
	* qmain_item.C (AtomItem::edit_child): Call it.
	(SequenceItem::edit_after): Ditto.
	* qmain_tree.C, qmain_tree.h, qmain_item.C, qmain_item.h
	(edit_after): Made it bool.
	* qmain.C (edit_after): Populate tree.

	* Version 1.61 released.

2000-10-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* depend.C, depend.h: Dumbed down tamplates for Bcc 5.01.

	* traverse_delete.C: Wrong include.

	* Version 1.60 released.

2000-10-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation.C (load_syntax): Make it possible to specify a
	`description' for a given vegetation.

	* lib/log.dai ("Vegetation"): Fix so it works on named
	vegetations. 

	* canopy_simple.h, canopy_simple.C (EpFacDS): New parameter.
	(EpFactor): New function.
	* crop_std.C (EpFac): Call it.
	* crop_simple.C (EpFac): Ditto.
	* vegetation_permanent.C (EpFactor): Ditto.

2000-10-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_activity.C (ActionActivitySyntax): Allow empty list.

	* parser_file.C (load_list): Fix memory leaks.

2000-10-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.59 released.

2000-10-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* chemicals.C (output): Always log, even when amount is 0.

	* log.h (Log::Unnamed): New member class.
	(output_vector): Use it.
	* action_lisp.C (ActionCond::output): Use it.
	* soil_chemicals.C (mix): Use it.

2000-10-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* printer_file.C (print_object): Always use `print_string' to
	print element.

	* weather.C, weather.h (initialize): New virtual member function.
	* weather_std.C (initialize): Implement it.
	* column_base.C (initialize): Call it.
	* daisy.C (initialize): Ditto.

	* log_checkpoint.C (done): Start checkpoint from next timestep.

	* om.C (OM): Initialize `C' array if present.

2000-10-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (output): Log `initial_C_per_N' even when unspecified. 
	(check_alist): Allow negative numbers.
	(load_syntax): Document negative numbers.
	(get_initial_C_per_N): Obey negative numbers.

	* qmain_item.C (edit_child): Implemented.

2000-10-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* qmain.C (edit_copy, edit_inherit): Populate tree.

2000-10-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* qmain.C (set_selection_copyable): Don't set inheritable.
	* qmain.C, qmain.h (set_selection_inheritable): New function.
	* qmain.C (clear_selection): Use it.
	* qmain_item.C (ModelItem::set_selected): Use it.
	(ModelItem::edit_copy): Implemented.
	(ModelItem::edit_inherit): Implemented.

2000-10-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* depend.h: Renamed from `traverse_depend.h'.
	* depend.C: Renamed from `traverse_depend.C'.
	* Makefile (OTHER): Update.
	* qmain_item.C: Update.
	* qmain_edit.C: Update.

	* qmain_item.C, qmain_item.h (container): New method to find the
	library and object a tree item.

	* traverse_depend.C, traverse_depend.h (had_dependencies,
	check_dependencies): New functions. 
	* traverse_depend.h (dep_map): New type.
	* traverse_depend.C (TraverseDepend):  Support it.

2000-10-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* qmain_edit.C, qmain_edit.h (EditList): New helper class.
	* qmain_edit.C (EditNumbers, EditIntegers, EditNames): New editors.
	(ItemDialog): Use them.

	* Version 1.58 released.

2000-10-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (load_list): Implement PLF sequences.

	* organic_matter.C (smb_tillage_factor, som_tillage_factor,
	tillage_age): New attributes.

	* alist.C (struct Value): Fix PLF sequence value.
	* column_std.C (swap, mix): Pass time to organic matter.

	* qmain_item.h, qmain_item.C (SimulationItem): New item.
	* qmain_populate.C, qmain_populate.h (populate_tree): Use it.
	* qmain_tree.C, qmain_tree.h (populate): Update caller.
	* qmain.C (populate_tree): Update caller.
	(MainWindow): Removed `Edit Simulation...' menu item.

	* Version 1.57 released.

2000-10-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (set_N): Don't assume fixed C/N ratio.

2000-10-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* qmain_item.C, qmain_item.h: Submodels and model are not raw editable.

	* qmain_edit.C, qmain_edit.h (EditObject): New editor.
	* qmain_edit.C (ItemDialog): Use it.

	* crop_old.C (SoluteUptake): Use `bound' instead of `min' and `max'.
	* crop_sold.C (SoluteUptake): Ditto.
	* root_system.C (potential_water_uptake): Ditto.
	(solute_uptake): Ditto.

2000-10-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* mathlib.h (bound, set_bound): New functions.
	* bioclimate_std.C (WaterDistribution): Use it.
	* groundwater_pipe.C (InternalGWTLocation): Ditto.
	* crop_sold.C (NetProduction): Ditto.
	* crop_std.C (NitrogenUptake): Ditto.
	* crop_old.C (NetProduction): Ditto.

	* qmain_tree.C (edit_delete): Only return true if we deleted a
	model. 

	* qmain_item.C (setSelected): Mark editable items as deletable.
	* alist.C, alist.h (revert): New function.
	* qmain_item.C (delete_item): Call it..
	* qmain_item.h, qmain_item.C (recreate_item): New function.
	* qmain_item.C (edit_item, delete_item): Call it.

	* qmain_populate.C (populate_parameter): Don't remove parameters
	if parent has `view_defaults' set.

	* qmain_edit.h, qmain_edit.C (EditBoolean): New editor.
	* qmain_edit.C (ItemDialog): Use it.
	
	* qmain_edit.C (EditDate): New editor.
	(ItemDialog): Use it.

2000-10-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.56 released.

2000-10-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* alist.C, alist.h (remove): New function.
	(add): Mark alist argument `const'.

2000-10-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* traverse_delete.h, traverse_delete.C: New files.
	* Makefile (OTHER): Add them.

	* select_interval.C: New density parameter.

2000-10-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* net_radiation.C, pet_PM.C, svat_pmsw.C: Merged SH changes.


2000-10-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.55 released.

2000-10-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_irrigate.C (ActionIrrigateStopSyntax): Fixed
	initialization bug.

2000-10-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C (PsychrometricConstant): Fix constant.
	(SlopeVapourPressureCurve): Ditto.

2000-09-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* qmain_edit.C, qmain_edit.h: New files.
	* Makefile (QTSOURCES): Add them.

	* Version 1.54 released.

2000-09-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* qmain_busy.C, qmain_busy.h: New files.
	* qmain_item.C, qmain_item.h: New files.
	* qmain_populate.C, qmain_populate.h: New files.
	* Makefile (QTSOURCES): Add them.

2000-09-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.h (screen_height): Renamed to `screen_height_'.
	* weather.C (Weather): Update caller.
	* weather_old.C (WeatherOld): Ditto.
	* weather_std.C (keyword_description): Ditto.
	* weather.h, weather.C (screen_height): New function.
	* pet_PM.C (PenmanMonteith): Take `ScreenHeight' argument instead
	of assuming 2.0 m.
	(tick): Use weather.screen_height () instead of assuming 2 m.

	* traverse_depend.h, traverse_depend.C: New utility.
	* Makefile (OTHER): Add it.
	* library.C, library.h (check_dependencies): Removed.
	* qmain.C (view_dependencies): Adjusted.
	
	* traverse.h, traverse.C: New utility.
	* Makefile (OTHER): Add it.

	* qmain_tree.h, qmain_tree.C: New file.
	* Makefile (QTSOURCES): New macro.
	(SOURCES): Use it.
	(HEADERS): Use it.
	(QTOBJECTS): New macro.
	(qdaisy${EXT}): Use it.
	($(QTOBJECTS)): New target.

	* lib/log.dai ("Crop Production"): Removed duplicate "WDead"
	entry. 

2000-09-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/grass.dai ("Grass to grain"): New "DSLAI05" value.

2000-09-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* alist.h, alist.C (operator =): New function.

	* Version 1.53 released.

2000-09-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* FILES: New file.
	* Makefile (TEXT): Added it.

	* treelog.h, treelog.C: New utility.
	* treelog_stream.h, treelog_stream.C: New utility.
	* Makefile (OTHER): Added them.
	* library.C, library.h (check_dependencies): New functions.
	* qmain.C, qmain.h (view_dependencies): New signal.
	
2000-09-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* tmpstream.C, tmpstream.h: New utility.
	* Makefile (OTHER): Added it.
	* librarian.h (class Librarian): Use it.
	* parser_file.C (load_list): Use it.
	* log_checkpoint.C (done): Use it.
	* document_LaTeX.C (print_submodel_entry): Use it.
	* chemicals.C (lookup): Use it.
	* common.h: No longer provide strstreams.

2000-09-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.52 released.

2000-09-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai: Merged PvdK changes.
	* svat_pmsw.C: Ditto.

	* library.C, library.h (refile_parsed): New static member function.
	* qmain.C, qmain.h (file_save_as): New signal.
	(MainWindow): Slot it. 

2000-09-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.51 released.

2000-09-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* qmain.C (save_file, file_save): New functions.

	* printer_file.C (is_complex): Ordered objects are always complex.

	* log.C, log.h, log_harvest.C, log_table.C (initialize): Removed.
	* daisy.C (Daisy): Update caller.
	* log.C, log.h (print_dlf_header): New static member function.
	* log_harvest.C, log_table.C (match): Call it.
	* parser_file.C (load): Save input in "parser_inputs" attribute.
	(~Implementation): Clear inputs.
	(load): Save file in "parser_files" attribute.
	* log_checkpoint.C (done): Use these daisy alist attributes.
	(libraries): Removed attribute.
	
	* alist.C (Value): Copy members of incomming alist, plf or time
	sequence. 
	* all: Update callers.

	* bioincorporation.C (~Bioincorporation): Delete impl.

2000-09-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (inputs): New data member.
	(load_list): Update it.

	* parser_file.C (load_list): Fix memory leak.

	* Version 1.50 released.

2000-09-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* library.C, library.h (clear_all_parsed): New function.
	* library.C (Implementation::clear_parsed): New function.
	* alist.C, alist.h (clear): New function.
	* qmain.C, qmain.h (file_new): New menu function.

2000-09-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Made the `check (Daisy*)' and the file parser take ostream
	arguments. 
	* qmain.C, qmain.h (file_load): New menu function.

	* horizon.C (check_alist): Check that `SOM_C_per_N' is at least
	one long.

2000-09-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* document_LaTeX.C (print_submodel_entry): Better value
	descriptions for alists, plf's and strings.
	* syntax.h, syntax.C (check): Take an ostream argument.
	* all: Updated callers.	
	* qmain.C, qmain.h (view_check): New menu function.

	* Version 1.49 released.

2000-09-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_std.C (fertilize): Merged inorganic and organic
	function variants. 
	* column.h, column_inorganic.C, field.h, field.C (fertilize): Ditto.
	* action_fertilize.C (doIt): Update caller
	* action_crop.C (fertilize): Ditto.

	* Version 1.48 released.

2000-09-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_fertilize.C (second_year_compensation): New parameter.
	* am.C, am.h (second_year_utilization): New function.
	* column_std.C (fertilize): Use it.
	* column_std.C (second_year_utilization): New state variable.
	* am.C (second_year_utilization): New parameter for organic
	fertilizer. 
	* field.h, field.C, column.h, column_std.C,
	column_inorganic.C (second_year_utilization,
	clear_second_year_utilization):  New function.
	* action_fertilize.C (tick): Use them.

	* action_fertilize.C (minimum_weight): New paramemter

	* am.C, am.h (set_utilized_weight): Moved to here.
	* action_fertilize.C (set_weight): Moved from here.
	(ActionFertilize, doIt): Updated caller.
	* am.C, am.h (utilized_weight): New function.

	* condition_time.C (ConditionMonthly::match): Used to match every
	hour in the month, except the last.  Reversed that.
	* condition_time.C (ConditionYearly::match): As above.


2000-09-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_std.C (fertilized_NO3, fertilized_NH4, fertilized_Org_N,
	fertilized_Org_C, fertilized_DM): New log variables.
	* lib/log.dai ("Fertilizer"): New log model.

	* im.C (IM_get_NO3, IM_get_NH4): Moved and renamed.
	* am.C, am.h (get_NO3, get_NH4): To here.
	* im.C (IM): Update caller.

	* common.C (find_file): Fix previous fix (missing return fd).

	* Version 1.47 released.

2000-09-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioincorporation.C (tick): Don't incorporate very tiny pools, to
	avoid numeric errors.

	* action_fertilize.C (struct ActionFertilize): Slightly better
	output messages.

	* am.C (smb_contribution): New function.
	* organic_matter.C (initialize): Use it.

	* weather_std.C (keyword_description): Latitude should be in [-90, 90].

	* weather_old.C (check_alist): Added warning about arctic
	agriculture. 
	(load_syntax): Don't use `add_submodule' template.

	* weather.C (day_length): Allow for arctic agriculture.

	* common.C (find_file): Also give error message when failing to
	open file specified by absolute path.

	* organic_matter.C (load_syntax): New default SMB and SOM
	parameters. 
	(initialize): Use soil clay content when initializing SMB pools.
	(initialize): Steal SOM[0] C for initializing SMB pools.

2000-09-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/wwheat.dai ("Winter Wheat; Eest"): Renamed from "Winter
	Wheat, Eest". 
	("Winter Wheat; Foulum"): Overwrite `CrpN' parameter.

	* lib/wbarley.dai ("Winter Barley; Koge"): Renamed from "Winter
	Barley". 
	("Winter Barley"): New parameterization.
	("Winter Barley; Foulum"): Ditto.

	* lib/fertilizer.dai (Ammonia): New parameterization.
	(AmmoniumNitrate): Ditto.
	(Nitrate): Ditto.
	(NPK): Ditto.
	(N25S): Ditto.
	(Foulum_slurry): Ditto.

	* Version 1.46 released.

2000-09-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C (day_length): Make call to `acos' safe.

	* action_irrigate.C (ActionIrrigateSubsoilSyntax): Fixed
	self-initialization alist bug.

	* alist.C, alist.h (empty): Removed.
	* gmain.C (daisy_add_entry): Fix caller.
	* printer_file.C (print_alist): Ditto.
	(print_library_file): Ditto.
	* syntax.C (default_alist): Use local empty alist.

	* soil_chemicals.h: Fix link dependency.

	* svat_pmsw.C: SH changes.

	* am.C (add): Removed dead code.

2000-09-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C (GroundwaterPipeSyntax): Cleanup dimensions.

	* all: Added more newslines to descriptions.

2000-09-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_crop.C (ActionCropSyntax): Rely on default alists.

	* Version 1.45 released.

2000-09-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (add): Don't assume permanent C/N.

	* parser_file.C (load_list): Use `Syntax::default_alist' also for
	singletons. 
	* document_LaTeX.C (print_entry_type): Ditto.
	(print_entry_submodel): Ditto.
	* printer_file.C (print_entry): Ditto.
	* syntax.C (add, add_submodule_sequence, add_submodule): Always
	set `default_alist' for submodels.
	* soil_chemicals.C (load_syntax): Fix caller.
	* organic_matter.C (load_syntax): Fix caller.
	* log_table1.C (LogTable1Syntax): Fix caller.

	* Version 1.44 released.

2000-09-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_fertilize.C ("precision"): New parameter.
	* field.C, field.h (soil_inorganic_nitrogen): New function.
	* column_inorganic.C, column_std.C, column.h
	(soil_inorganic_nitrogen):  New function.
	* solute.C, solute.h (total): New function.
	
	* lib/fertilizer.dai (slurry): Renamed `NH4_evaporation' to
	`volatilization'. 

2000-09-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_fertilize.C (equivalent_weight): New parameter.
	* am.C (weight): Gave default value `0.0' for mineral and
	organic weight.
	(first_year_utilization): New parameter for organic fertilizer. 

	* root_system.C (load_syntax): Made it a submodel.
	* canopy_std.C (load_syntax): Ditto.
	* canopy_simple.C (load_syntax): Ditto.

	* lib/log.dai ("N Balance"): Renamed `Total-NO3' to `NO3-Total'.

	* Version 1.43 released.

2000-09-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Root Zone Water Balance"): Log external sink.

	* column_std.C, action_irrigate.C: Changed irrigation solute units
	from g/mm to mg N/liter.

	* action_irrigate.C (ActionIrrigateStop): New model.

2000-09-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_irrigate.C (ActionIrrigateSubsoil): New model.
	* field.C, field.h (set_subsoil_irrigation): New function.
	* column_std.C, column_base.C, column_base.h, column.h
	(set_subsoil_irrigation): New function.
	* soil_water.C, soil_water.h (S_permanent): New state variable.
	(set_external_source): New member function.
	* solute.C, solute.h (S_permanent): New state variable.
	(set_external_source): New member function.

	* Version 1.42 released.

2000-09-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (check_organic): Warn of obsolete parameter
	`NH4_evaporation' is used. 

	* action_irrigate.C (check_alist): Check for negative numbers.

	* groundwater_static.C (check_alist): New function, warn that this
	model is obsolete.

	* All: Renamed `top irrigation' to `overhead irrigation'.
	* action_irrigate.C: Created an obsolete `irrigate_top' action.

	* Makefile (FTPDIR): New macro.
	(dist): Use it.
	(WWWINDEX): New macro.
	(dist): Use it.

'2000-09-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.41 released.

2000-09-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* NEWS: New file.
	* Makefile (TEXT): Add it.
	(dist): Copy `NEWS' and `ChangeLog' to ftp directory.

	* log_harvest.C (LogHarvestSyntax): Default filename `harvest.dlf'
	instead of `harvest.tab'.

	* lib/log.dai: Renamed all files generated by `table'
	parameterizations from ".tab" to ".dlf".

	* solute.C, soil_NH4.C, soil_NO3.C, solute.h, soil_NH4.h,
	soil_NO3.h (default_initialize): New virtual member function.
	* solute.C, (initialize): Call it.

	* Version 1.40 released.

2000-09-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_repeat.C: New file.
	* Makefile (MODELS): Add it.

	* action_lisp.C (ActionT): New model.

2000-09-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (add): New member function.

	* om.C, om.h (grow): New member function.
	(add): Call it.
	(add): Two new member functions.

	* crop_std.C (NoProduction): New member function.
	(DevelopmentStage): Call it.

	* bioclimate_std.C (WaterDistribution): Don't ignore surface
	irrigation.

2000-09-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_std.C (WaterDistribution): Allow for larger numeric
	errors in canopy storage assertion. 

2000-09-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.39 released.

2000-09-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.C (tick): Use return value if `UZmodel::tick'.

	* Makefile (QTINCLUDE, QTLIB): New macros.
	(qmain${OBJ}): New target.
	(qdaisy${EXT}): New taget.
	(daisy.so): New target.

2000-09-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzmodel.h, uzlr.C, uzrichard.C, uznone.C (tick): Return true on
	success.
	* common.h (WORKING_EXCEPTIONS): new flag.
	* uzrichard.C (richard): Return false if exceptions doesn't work.


2000-09-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.38 released.

2000-09-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_chemical.C (decompose): Made `organic_matter' optional.
	* soil_chemicals.C (tick): Ditto.

	* crop_sold.C, crop_old.C, crop_simple.C, crop_std.C, crop.h
	(tick): Made organic matter and nitrogen optional. 
	* vegetation_permanent.C, vegetation_crops.C, vegetation.h (tick):
	Version without organic matter or nitrogen.

	* crop_std.C (harvest): Make dead leafs and dead root residuals if
	crop hasn't emerged.

2000-08-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* field.C, field.h, column_base.C, column.h, action_harvest.C,
	action_crop.C (harvest):  Take harvest as argument, instead of
	returning it.

	* crop.h, crop.C, crop_std.C, crop_old.C, crop_sold.C,
	crop_simple.C (harvest): Take `residuals' argument instead of
	`organic_matter'. 
	* vegetation_crops.C (harvest): Update caller.
	* crop.h, crop.C (kill): Update caller.
	* vegetation_crops.C (kill_all): Update caller.

	* surface.C, surface.h (mixture): Split into two.

	* crop.h, crop.C, crop_std.C, crop_old.C, crop_sold.C,
	crop_simple.C (initialize): Version without `organic_matter'
	parameter. 
	* vegetation_permanent.C, vegetation_crops, vegetation.h (sow):
	Version without `organic_matter' parameter.

	* lib/log.dai ("Surface Water Balance"): Log `production_stress'.

	* Version 1.37 released.

2000-08-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/Makefile (DAISY): Added `vegetation.dai'.

	* lib/log.dai ("PMSW"): Change `pt' to `svat'.

2000-08-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_inorganic.C: New model.
	* Makefile (MODELS): Added it.

	* column_base.C, column_base.h: New files.
	* column_std.C: Use them.
	* Makefile (SPECIALS): Add it.

2000-08-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* solute.C, solute.h (S_external): New log variable.
	(add_external): Renamed from `add'.
	* column_std.C (fertilize): Update caller.
	* lib/log.dai ("N Balance"): Log it.
	("Soil Chemicals"): Ditto.

2000-08-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.36 released.

2000-08-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai: Use `daily' instead of `(hour 0)'.

	* condition_time.C (ConditionWeekly): Log sunday.
	(ConditionMonthly): Log last hour of month.
	(ConditionYearly): Log last hour of year.
	(ConditionTimeSyntax): Fix descriptions.

	* time.C (wday_number): Implemented.
	(wday_name): Ditto.
	(week): Ditto.
	(wname): New static const data member.
	(mname, mlen): Made const.
	* time.h, time.C (yday2wday): New static member function.
	(yday2week): Ditto.

2000-08-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Weather"): Use `daily' log.

	* condition_time.C (ConditionDaily, ConditionWeekly,
	ConditionMonthly): Log at 23. 

2000-08-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.35 released.

2000-08-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop.h (water_stress, nitrogen_stress, production_stress):
	Inverted semantic so 0 is full production, and 1 is no production.
	* crop_old.C (tick): Ditto.
	* crop_std.C (tick): Ditto.
	* crop_sold.C (tick): Ditto.
	* crop_simple.C (class CropSimple): Ditto.
	* crop_std.C (NitrogenUptake): Ditto.
	* root_system.C (water_uptake): Ditto.

	* bioclimate_std.C (production_stress): New member.
	* vegetation.h, vegetation.C, vegetation_crops.C
	(force_production_stress): New virtual member function.
	* crop.h, crop.C, crop_std.C, crop_simple.C
	(force_production_stress): New virtual member function.
	* root_system.h, root_system.C (production_stress): New member.
	* crop_std.C (tick): Use it.

2000-08-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.34 released.

2000-08-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.33 released.

2000-08-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Renamed `pt' component `svat'.

	* action_crop.C (doIt): Don't check for harvest before sowing.

2000-08-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Crop Production"): Added `NDead' and `WDead'.

2000-08-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.32 released.

2000-08-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_crop.C (ActionCropSyntax): Make optional submodules use
	`dummy' attribute list.

2000-08-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.31 released.

2000-08-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/Makefile (CLIMATE): Use `weather.dwf' instead of `weather.clm'.
	(cvs): Add $(CLIMATE) to CVS.

	* Version 1.30 released.

2000-07-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation_permanent.C: Added forward declarations of templates.
	* action_ridge.C: Ditto.

2000-06-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.29 released.

2000-06-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_crop.C (ActionCropSyntax): Added default empty lists for
	`fertilize_at', `tillage, and `spray'.

2000-06-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil.C (load_syntax): Gave default value for `dispersivity'.

2000-06-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/vegetation.dai: New file.
	(Coniferous): New model.

	* canopy_simple.C (load_syntax): Changed default value for rs_min
	from 0.0.

2000-06-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.28 released.

2000-06-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("N Balance"): Use crops vegetation model.
	("Crop Photosynthesis"): Ditto.
	("Crop Production"): Ditto.
	("Simple Crop Production"): Ditto.
	("Old Crop Production"): Ditto.
	("Permanent Vegetation"): New model.

2000-05-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation_permanent.C: New model.

	* vegetation_crops.C, vegetation.h (initialize): Make it take a
	soil argument. 

	* root_system.C (set_density, full_grown): New functions.

2000-05-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation.h, vegetation.C: Made it a component instead of a
	submodel.
	* vegetation.C: New model.

	* Makefile (SUBMODEL): Removed `vegetation.C'.
	(COMPONENTS): Added `vegetation.C'.
	(MODELS): Added `vegetation_crops.C'.

2000-05-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.27 released.

2000-05-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_std.C, bioclimate.h, column_std.C, column.h, field.C,
	field.h (irrigate_surface, irrigate_top): Made
	temperature optional.
	* action_crop.C (doIt): Use it.
	* action_irrigate.C: Ditto.

	* column_std.C: Added column specific weather.
	* daisy.C, daisy.h: Made global weather optional.
	* field.h, field.C, column.h: Ditto.

	* Version 1.26 released.

2000-05-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_harvest.C (print_header): New data member.
	(match, LogHarvest): Use it.
	(initialize): New member function.
	
	* log_table.C (default_description): New static data member.
	(LogTableSyntax): Use it.
	(LogTable): Use it.

	* log.h, log.C, log_table.C (initialize): New virtual member
	function. 
	* daisy.C (Daisy): Use it.
	
	* log_select.C (load_syntax): Fixed `description'.

2000-05-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C (print_header): New member.
	* log_table.C (LogTable, done): Obey it.

2000-05-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_simple.C: Added support for `LAIvsDay'.

2000-05-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_simple.C (tick): Inserted missing `else'.
	(tick): Only demand N after emergence.
	(CropSimple): Ditto.

	* uzrichard.C (richard): Don't whine if top.h () == 0 for a
	pressure top.

	* root_system.C (load_syntax): Gave default value for `MaxPen'.
	* canopy_simple.C (load_syntax): Gave default value for `PARext'.
	* crop_simple.C (CropSimpleSyntax): Gave default value for
	`height_max'. 
	(potential_N): Renamed from `harvest_N'.
	(CropSimple): Fix initialization of `spring_mm' and `spring_dd'.
	(harvest): Kill it off.

	* am.C (AM::AM): Added cast in the hope of making BCC 5.02 happy.

2000-05-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_simple.C: New model.
	* Makefile (MODELS): Add it.
	* lib/log.dai ("Simple Crop Production"): New log model.

	* main.C (main): Catch standard exceptions.

	* plf.C, plf.h (first_interesting, last_interesting, max_at): New
	member functions. 

	* daisy.C: Removed `crop.h' include.

	* crop.C, crop.h (default_AOM): New static member function.
	* crop_std.C (CropStandardSyntax): Use it.

2000-05-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_old.C (CropOldSyntax): Fixed PenPar1 dimension.
	* crop_sold.C (CropSoldSyntax): Ditto.
	* root_system.C (load_syntax): Ditto.

	* surface.C (load_syntax): Fixed runoff dimensions.
	* lib/log.dai ("Surface Water Balance"): Ditto.
	("Root Zone Water Balance"): Ditto.
	("N Balance"): Ditto.
	("Bioclimate"): Ditto.

2000-05-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* canopy_simple.C, canopy_simple.h: New submodel.
	* Makefile (SUBMODELS):  Add it.
	* canopy_std.C, canopy_std.h: Use it.
	
xb2000-05-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.25 released.

2000-05-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* canopy_std.C, canopy_std.h: New submodule.
	* Makefile (SUBMODELS): Add it.
	* crop_std.C: Use it.
	
	* crop_std.C: Fixed spelling errors.

2000-05-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* root_system.C, root_system.h: New submodel.
	* Makefile (SUBMODELS): Added it.
	* crop_std.C): Use it.

	* document_LaTeX.C (print_entry_type): Removed dead code.

	* Version 1.24 released.

2000-05-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/chemistry.dai (Bentazon, IPU, MCPP): New models.

2000-05-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzrichard.C (richard): Don't switch to pressure top with upward
	flux. 

	* action_crop.C: Added support for spraying.

	* soil_chemicals.C (mixture): Fix sign error.

2000-05-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzrichard.C (richard): Updated for ridge top.
	* uzlr.C (tick): Ditto.

	* lib/log.dai ("Ridge"): New model.
	("Soil Water Sink"): Ditto.

2000-04-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzmodel.h, uzmodel.C, surface.h, surface.C (ridge_top): New
	virtual member function. 

2000-04-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/wwheat.dai ("Winter Wheat"): Change `MxNH4Up' to match
	`MxNO3Up'. 

2000-04-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (AccFixated): New data member.

	* lib/log.dai ("Crop Production"): Use `AccFixated' instead of
	`Fixated'. 

2000-03-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.C, soil_water.h (set_h): New function.

2000-03-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.23 released.

2000-03-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* harvest.C, harvest.h: Added `dead_DM' and `dead_N'.
	* crop_std.C, crop_old.C, crop_sold.C (harvest): Ditto.
	* log_harvest.C: Ditto.
	* lib/log.dai ("Crop Production"): Ditto.
	* crop_std.C (DM): Use `dead_DM'.

2000-03-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* surface.C (ridge): New optional state variable.
	* surface.C, surface.h (unridge): New function.
	* column_std.C (mix): Call it.
	* surface.C, surface.h (ridge): New function.	
	* column_std.C, column.h (ridge): New function.
	* field.C, field.h (ridge): New function.
	* ridge.C, ridge.h: New submodel.
	* Makefile (SUBMODELS): Added it.
	* action_ridge.C: New model.
	* Makefile (MODELS): Added it.
	* soil_water.C, soil_water.h (set_Theta): New function.
	* surface.C (node_below): New function.
	* soil_water.C (tick): Use it.
	* surface.C, surface.h (tick_soil): New function.
	* column_std.C (tick): Call it.

2000-03-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.22 released.

2000-03-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (print): Removed target.

	* syntax.C, syntax.h (domain, range): New member functions.
	(add): Support them.
	* document_LaTeX.C (print_entry_type): Use them.
	* bioincorporation.C (load_syntax): Specify them.
	* crop_std.C (CropStandardSyntax): Ditto.
	* crop_sold.C (CropSoldSyntax): Ditto.
	* crop_old.C (CropOldSyntax): Ditto.
	* chemical_std.C (ChemicalStandardSyntax): Ditto.
	* denitrification.C (load_syntax): Ditto.
	* soil_chemical.C (load_syntax): Ditto.
	* nitrification_solute.C (NitrificationSoluteSyntax): Ditto.
	* organic_matter.C (load_syntax): Ditto.
	* nitrification_soil.C (NitrificationSoilSyntax): Ditto.
	* macro_std.C (MacroStandardSyntax): Ditto.
	* hydraulic_M_vG_compact.C (HydraulicM_vG_compactSyntax): Ditto.
	* vegetation.C (load_syntax): Ditto.

	* action_message.C (ActionMessageSyntax): Fix order.

2000-03-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.21 released.

2000-03-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Renamed CSMP to PLF.

	* Version 1.20 released.

2000-03-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* csmp.h, csmp.C (offset): New function.

	* geometry.h, geometry.C (interval): Removed.
	* geometry.C (swap): Use `interval_plus' instead of `interval'.
	* uzlr.C (tick): Ditto.
	* uzrichard.C (q_darcy): Ditto.
	* column_std.C (soil_temperature): Ditto.
	(soil_water_potential): Ditto.

2000-03-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* common.C (Options): Check for arg size.

	* Version 1.19 released.

2000-03-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_fixed.C: New model.
	* groundwater_deep.C: New model.
	* Makefile (MODELS): Added them.
	* groundwater_static.C (GroundwaterStaticSyntax): Fixed description.

2000-02-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.C, syntax.h (Fraction): New dimension.
	* parser_file.C (load_list): Check for fractions.
	* action_crop.C, action_tillage.C, am.C, om.C, action_harvest.C,
 	action_tillage.C, bioincorporation.C: Updated dimensions. 
	* chemical_std.C (ChemicalStandardSyntax): Ditto.
	* weather.C (load_syntax): Ditto.
	* surface.C (load_syntax): Ditto.
	* soil_water.C (load_syntax): Ditto.
	* om.C (load_syntax): Ditto.
	* horizon.C (load_syntax): Ditto.
	
	* Version 1.18 released.

2000-02-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* event.C, eventqueue.C, minimanager.C: Removed files.

	* soil_heat.C (S): New data member.
	* soil_heat.h, soil_heat.C (set_source): Set it.
	* column_std.C, column.h (set_heat_source): New function.
	* field.h, field.C (set_heat_source): New function.
	* action_heat.C: New model.
	* Makefile (MODELS): Added it.

	* Version 1.17 released.

2000-02-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_M_vG_compact.C: New model.
	* Makefile (MODELS): Added it.
	* hydraulic.C, hydraulic.h (set_porosity): New function.
	* soil.h (set_porosity): New function.
	* column.h, column_std.C (set_porosity): New function.
	* field.C, field.h (set_porosity): New function.
	* action_tillage.C (ActionSetPorosity): New model.

2000-02-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic.C, hydraulic.h (name): New data member.
	* hydraulic.C, hydraulic.h (compact): Removed.
	* uzrichard.C (internode): Remove caller.
	* soil.h (compact): Remove caller.
	* soil.C, soil.h (Implementation): New member class.
	(impl): New member.
	* hydraulic.C, hydraulic.h (output): New function.
	* horizon.C (output): New function.
	* soil.C, soil.h (output): New function.
	* column_std.C (output): Call it.

2000-02-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_std.C, column.h (set_surface_detention_capacity): New
	function. 
	* field.C, field.h (set_surface_detention_capacity): New function.
	* surface.C (DetentionCapacity): Made it a state variable instead
	of a constant.
	* surface.C, surface.h (set_detention_capacity): New function.
	* action_surface.C: New file.
	* Makefile (MODELS): Add it.

2000-02-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.16 released.

2000-02-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_std.C (WaterDistribution): Don't assume total_ep >=
	total_ea. 

2000-02-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* common.C (find_file): Throw error if file is not found.

	* common.h (acos, asin): Check domain.

2000-02-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioincorporation.C (tick): Spelling fix.
	(tick): AOM pools can have identical C/N.

2000-02-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.15 released.

2000-02-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/grass.dai: Merged SH changes.

	* am.C (mix, swap): Give warning instead of error when mass
	doesn't balance. 

2000-02-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.14 released.

2000-02-10  Per Abrahamsen  <abraham@dina.kvl.dk>


	* am.h (class AM): Make constructor private.
	* am.C (create): Be sure to create as "state".
	(AM_Syntax::make): Ditto.

	* om.C (output): Don't log unspecified `initial_C_per_N'.

	* bioincorporation.C, bioincorporation.h (output): Don't take
	geometry parameter.
	* organic_matter.C (output): Updated caller.
	* bioincorporation.C (load_syntax, output): Removed `soil_N' and
	`soil_C'. 
	* lib/log.dai (Bioincorporation): Updated log model.
	(AOM): Renamed from (AM).  Updated tags.

	* om.C (set_N): Use CERR instead of assert.

2000-02-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.13 released.

2000-02-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai (AM): New log model.

	* om.C, am.C (add): Survive when `to_C' much smaller than `old_C'.
	Ditto, for N.

	* soil_water.C (tick): Ignore tiny numeric errors on ice.

2000-02-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.C (open_maybe): Avoid `static const string', it crashed
	BC++5.0. 

2000-02-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.C (maybies): Don't use a stack, use a plain vector.

	* Version 1.12 released.

2000-02-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.h, select.C (open_maybe, close_maybe): New member
	functions. 
	* log.h, log.C, log_select.h, log_select.C (open_maybe,
	close_maybe): New virtual member functions.
	* log.h (Maybe): New member class.
	* soil_chemicals.C, chemicals.C, am.C (output): Use it.

2000-02-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_array.C, select.C, select.h (size): New virtual member
	function.
	* log_table.C (done): Use it.

2000-02-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C (print_dimension, print_tags): New data member.
	(done): Use them.
	(LogTable): Initialize them.
	* select.C, select.h (geometry): New virtual member function.
	* select_array.C (last_geometry): New data member.
	(output_array): Set it.
	(SelectArray): Initialize it.
	(geometry): New member function.

	* Version 1.11 released.

2000-02-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (set_N): Don't set C/N to one when already specified.

2000-01-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.10 released.

2000-01-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (harvest): Also handle `stub_length >= length'.

2000-01-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* geometry.C (check_alist): Don't allow zero-sized layers.

2000-01-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pt_pmsw.C (PT_PMSWSyntax): Add `f_theta'.

2000-01-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (AM_Syntax): Add `volatilization' as prefered alias for
	`NH4_evaporation'. 
	* im.C (IM_get_NH4): Update user.

2000-01-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* chemical_std.C (crop_uptake_reflection_factor): Added default
	value. 

2000-01-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.09 released.

2000-01-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C: (RootSystem): New submodule.
	* lib/log.dai ("Crop Production"): Updated caller.

	* horizon.C (load_syntax): Updated default values for
	`quarts_in_clay', `quarts_in_silt', `quarts_in_sand',
	`quarts_form_factor' and `mineral_form_factor'. 

2000-01-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.08 released.

2000-01-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* tortuosity_linear.C (TortuosityLinearSyntax): Add default value
	for the `b' parameter.

	* organic_matter.C (heat_factor, water_factor, clay_factor): New
	parameters. 
	* nitrification_soil.C, nitrification_solute.C (heat_factor,
	water_factor): New parameters.
	* column_std.C (ColumnStandardSyntax): Add them to default
	nitrification model..
	* dendenitrification.C, denitrification.h (heat_factor,
	water_factor): New parameters.

	* chemical_std.C (decompose_heat_factor_, decompose_water_factor_,
	decompose_CO2_factor_, decompose_conc_factor_,
	active_groundwater_): Made them const.

1999-12-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.07 released.

1999-12-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_chemicals.C, soil_chemicals.h (mixture): New member function.
	* surface.C, surface.h (mixture): Take `SoilChemicals' argument.
	* column_std.C (tick): Update caller.

	* soil_chemicals.C (Implementation::add_missing): New function.
	(Implementation::tick): Call it.

	* macro_std.C (pond_max): New parameter.

1999-12-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* alist.C (lookup): Give better error message when looking up a
	missing key.

	* bioclimate_std.C, bioclimate.h, surface.C, surface.h: Move
	surface chemicals from bioclimate to surface.
	* column_std.C (put_surface_chemical, get_surface_chemical, tick):
	Update caller.

	* lib/log.dai ("Surface Chemicals"): Update logger.

1999-12-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.06 released.

1999-12-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (tick): Don't let `active_underground' stop
	mineralization above one meter.

	* am.C (distribute): Added assertions.
	Use `initial_C_per_N' instead of `C_per_N[0]' when 
	`missing_fraction != missing_C_per_N'.
	Handle case where there is too little N.

1999-12-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/grass.dai (Grass): Changed `TLLeafEff'.

	* daisy.C (load_syntax): Made manager `State' instead of `Const'.

	* bioincorporation.C, bioincorporation.h: New submodel.
	* Makefile (SUBMODELS): Added it.
	* organic_matter.C (bioincorporation, top_CO2): New members.
	* lib/log.dai (Bioincorporation): New log model.

	* csmp.C, csmp.h (integrate): New member.

1999-12-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (multiply_top, top_C, top_N): New member functions.

	* organic_matter.C (om_compare): Made it a member of
	`OrganicMatter::Implementation'. 

	* om.C (load_syntax): Fixed type for `top_N'.

1999-12-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (MODELS): Renamed from `COMPONENTS'.
	(INTERFACES): Split `INTERFACES' into `COMPONENTS', `SUBMODELS',
	`SPECIALS', `OTHER' and `JRI'.
	(wc-split): New target.

	* Version 1.05 released.

1999-12-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log.h (output_submodule_log_only): Removed.
	* bioclimate_std.C (output): Updated caller.
	* harvest.C (output): Ditto.

	* organic_matter.C (initialize): Survive SOM initialization below
	lowest node.
	* geometry.C (initialize_layer): Same for other layered 
	initializations.

1999-12-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_crop.C: New model.
	* Makefile (COMPONENTS): Add it.

	* crop_std.C (harvest): Create dead root pool when killing
	unemerged crop in a tillage operation.

1999-12-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation.C (harvest): Obey "all".

1999-12-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_wait.C (ActionWaitSyntax::check_mm_dd): New function.
	(ActionWaitSyntax::ActionWaitSyntax):: Call it.

	* Version 1.04 released.

1999-12-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_flux_bottom.C (output_array): Fix off-by-one error.

1999-12-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_lysimeter.C: New model.
	* Makefile (COMPONENTS): Added it.
	* uzrichard.C (richard): Added lysimeter support.
	* uzmodel.C, uzmodel.h (UZbottom::is_lysimeter): New member
	function. 

1999-12-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* common.h (pow): First argument to pow can be 0.

	* syntax.C (check): Add level indicator.

1999-11-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (check_alist): New function.
	(load_syntax): Add it.

1999-11-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.03 released.

1999-11-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (add): Added assertions.

	* om.C (swap): Added assertions.
	(mix): Ditto.

	* pt_pmsw.C (RSC): Added assertions.
	(tick): Initialize rcmin to LAI/200.

	* Version 1.02 released.

1999-11-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* surface.C (mixture): No mixing when `total_matter_flux' is
	enabled. 

1999-11-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_M_C.C (HydraulicM_CSyntax::check): New function.
	(HydraulicM_CSyntax::HydraulicM_CSyntax): Use it.
	* hydraulic_B_C.C (HydraulicB_CSyntax::check): New function.
	(HydraulicB_CSyntax::HydraulicB_CSyntax): Use it.

1999-11-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Crop Photosynthesis"): Fixed OM CO2.

1999-11-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.01 released.

1999-11-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_hourly.C (put_air_temperature,
	put_reference_evapotranspiration): New member functions.

1999-11-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 1.00 released.

1999-11-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Merged pvdK changes.

1999-11-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_max.C: New model.
	* select_average.C: Ditto.
	* select_min.C: Ditto.

	* action_message.C: New file implementing the "assert", "message",
	"warning", and "error" actions.
	* Makefile (COMPONENTS): Add it.

1999-11-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.99 released.

1999-11-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Surface Water Balance", "Root Zone Water Balance",
	"N Balance", "Bioclimate"): Added surface runoff.

1999-11-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_std.C, bioclimate.h (tick): Removed `time' argument.
	* column_std.C (tick): Updated caller.

	* surface.C (DetentionCapacity, ReservoirConstant, runoff,
	im_runoff): New parameters and log variables.
	(tick, output): Use them.
	(R_mixture): New parameter.
	* surface.C, surface.h (mixture): New function.
	(clear): Removed.
	* column_std.C (tick): Call it.


1999-11-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.98 released.

1999-11-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C (tick_after): Convert FAO units.

	* pet_PM.C (tick): Convert FAO units.

1999-11-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Merged cygwin and BC5 changes.

	* weather_std.C: Added `RelHum' data type.

	* Merged SH changes.

	* hydraulic_M_vG.C (Se): Added assertions.

	* Version 0.97 released.

1999-11-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C, weather.h, weather_std.C (check): New function.
	* daisy.C (check): Call it.

	* Version 0.96 released.

1999-11-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C, weather.h (tick_after): New function.
	* weather_file.C, weather_hourly.C, weather_none.C, weather_old.C,
	weather_simple.C, weather_std.C: (tick): Call it.

	* weather.C, weather.h (T_normal): New function.
	(T_amplitude, T_average, max_Ta_yday): Removed functions.
	* soil_heat.C (bottom): Updated caller.

	* time.C, time.h (hours_between): New function.

1999-11-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lexer_data.C, lexer_data.h: New files.
	* Makefile (INTERFACES): Add it.
	* weather_std.C: New model.
	* Makefile (COMPONENTS): Add it.

1999-10-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C, weather.h (hourly_cloudiness, daily_cloudiness): New
	functions.
	* weather.h, weather_old.h, weather_old.C, weather_hourly
	(cloudiness): Removed. 
	* pt_pmsw.C, pet_PM.C, net_radiation.C (tick): Updated callers.

1999-10-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C, weather.h: (daily_extraterrastial_radiation): Removed.

	* weather_old.C (wind): Changed default wind from 0 to 3.

1999-10-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cdaisy.h: Added header file protection.

	* log_table1.C (~LogEntry): Deleted address of pointer.

	* lib/Makefile (NEWCROPS): Added fodderbeet.dai.

1999-10-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Merged SH changes.

	* Version 0.95 released.

1999-10-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (total_C, total_N): Made these log variables
	arrays. 
	* am.C, am.h, om.C, om.h (C_at, N_at): New functions.

	* lib/fodderbeet.dai ("Fodder Beet"): New file.
	* lib/crop.dai: Added it.

1999-10-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.h (timezone, screen_height): New data members.
	* weather_old.C (WeatherOld, WeatherOldSyntax): Initialize them.

	* Version 0.94 released.

1999-10-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Merged SH changes.

	* lexer.C, lexer.h: New files.
	* Makefile (INTERFACES): Add them.
	* parser_file.C: Use them.

1999-10-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.h, weather.C: Move most functionality to weather_old.C.
	* weather_old.h, weather_old.C: New files.
	* Makefile (INTERFACES): Added it.
	* weather_file.C: Derive from WeatherOld.
	* weather_none.C: Ditto.
	* weather_simple.C: Ditto.
	* weather_hourly.C: Ditto.

1999-10-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.93 released.

1999-10-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* common.h (sqrt): Check for negative numbers.

1999-10-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Hourly Groundwater"): Changed to table.
	("Total Soil Content"): Ditto.
	("Soil Nitrate Concentration"): Ditto.
	("Preferential Water Flux"): Ditto.
	("Preferential NO3 Transport"): Ditto.
	("Preferential NH4 Transport"): Ditto.
	("Surface Water Balance"): Ditto.
	("Soil Chemicals"): Ditto.
	("Soil Chemicals 0-100 cm"): New model.
	("Weather"): Changed to table.
	("Crop Photosynthesis"): Ditto.
	("Crop Production"): Ditto.
	("Old Crop Production"): Ditto.
	("Vegetation"): Ditto.
	("Surface Chemicals"): Ditto.
	("Bioclimate"): Ditto.

	* printer_file.C (FoundEntry::operator<): Added return type.

1999-10-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("N Balance"): Made interval parameterizable.
	("N Balance 0-100 cm"): New parameterization.
	("Root Zone Water Balance"): Use `table', made interval
	parameterizable.
	("Root Zone Water Balance 0-100 cm"): New parameterization.

1999-10-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.92 released.

1999-09-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* surface.C (evap_pond): Avoid negative numbers.

	* bioclimate_std.C (WaterDistribution): Added assertions.

1999-09-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_interval.C (SelectIntervalSyntax): Make `from' optional.

	* select_flux_bottom.C, select_flux_top.C: New select models.
	* Makefile (COMPONENTS): Added them.

1999-09-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C (tick): Make daycycle work right when the day length
	is less than 8 hours.

	* lib/log.dai ("Drain Sink Water", "Drain Sink NO3", "Drain Sink
	NH4"): New log models.
	("Root Zone Water Balance", "N Balance", "Soil Chemicals"): Add
	drainage. 

1999-09-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.91 released.

1999-09-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* solute.C, solute.h (S_drain): New sink term.
	* solute.C (tick): Update it.

	* uzrichard.C (UZRichardSyntax): Fix multiline string.

	* soil_water.h, soil_water.C (S_sum, S_root, S_drain): Split S
	into these.  
	* soil_chemical.C (uptake): Use it.
	* soil_heat.C (calculate_freezing_rate): Use them.
	* soil_water.h, soil_water.C (add_to_sink, root_uptake) Renamed
	`add_to_sink' to `root_uptake'.
	* crop_std.C, crop_old.C, crop_sold.C: Renamed callers.

1999-09-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* macro_std.C (tick): Added assertions.

	* uzrichard.C (UZRichardSyntax): Added description of default
	K_average. 

	* Merged SH changes.

1999-09-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.90 released.

1999-09-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C (initialize): Added warning for
	large soil intervals.

	* Merged SH changes.

1999-08-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_chemical.h, soil_chemical.C (lag, lag_increment): New
	members. 
	* soil_chemical.C (decompose): Use them.

	* chemical_std.C, chemical.h (decompose_conc_factor): New
	member function. 
	* soil_chemical.C (decompose): Call it.

	* Merged SH changes.

1999-08-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzrichard.C (richard): Fix memory error.

	* lib/log.dai ("Groundwater"): Added `DrainFlow'.
	* Merged SH changes.

1999-08-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.89 released.

1999-08-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.C, soil_water.h (first_groundwater_node): New
	function. 
	* denitrification.C (tick): Call it.
	* soil_heat.C:  Call it.
	* organic_matter.C (tick):  Call it.
	* nitrification_solute.C (tick):  Call it.
	* nitrification_soil.C (tick):  Call it.
	* organic_matter.C, organic_matter.h (tick): Remove groundwater
	parameter. 
	* soil_heat.C, soil_heat.h (tick): Ditto.
	* soil_heat.C (solve): Ditto.
	* denitrification.C, denitrification.h (tick): Ditto.
	* nitrification.h (tick): Ditto.
	* nitrification_solute.C (tick): Ditto.
	* nitrification_soil.C (tick): Ditto.
	* column_std.C (tick): Updated caller.
	* chemical_std.C, chemical.h (active_groundwater): New query
	function. 
	* soil_chemical.C (decompose): Use it.

	* cdaisy.h (daisy_log_get_array): Return void.

1999-08-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_interval.C (initialize): Make sure `default_from'
	overwrites `from' when unspecified.

	* Version 0.88 released.

1999-08-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.C (output_time): Renamed from `output'.
	(output_number): Ditto.
	(output_integer): Ditto.
	(output_name): Ditto.
	(output_array): Ditto.
	* select_array.C, select_content.C, select_date.C, select_flux.C,
	select_index.C, select_interval.C, select_number.C: Ditto.
	* log_select.C (output): Updated called.

	* log_alist.C, log_alist.h (check): Removed.

	* Merged PvdK changes.
	* Merged SH changes.

	* soil_heat.C (GROUND_WATER_LIMIT): Enable.

1999-08-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt/reference/introduction.tex (Log File Generation): Use
	`table' instead of `table1'. 

1999-08-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.87 released.

1999-08-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.h, select.C: Include `condition.h' from header file, in
	order to ensure proper initialization.

1999-08-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.86 released.

1999-08-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_M_BaC.C (Se): Ekstra tests.

1999-07-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.85 released.

1999-07-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.84 released.

1999-07-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_heat.C (update_state): Allow for numeric errors.

1999-07-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C: New file.
	* Makefile (COMPONENTS): Added it.

1999-07-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (harvest): Don't recreate canopy if crop hasn't
	emerged. 

1999-07-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.83 released.

1999-07-09  Per Abrahamsen  <abraham@dina.kvl.dk>


	* groundwater.C, groundwater.h (Groundwater): Take alist argument.
	* groundwater_static.C (GroundwaterStatic): Updated caller.
	* groundwater_file.C (GroundwaterFile): Updated caller.

1999-07-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzlr.C (tick): Didn't work when flux was too large.

	* soil_water.h, soil_water.C (X_ice_buffer): New member.
	(X_ice_total): New member function.

1999-07-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* snow.C, snow.h (tick): Add `Pond' argument.
	* bioclimate_std.C (WaterDistribution): Update caller.

	* snow.C (tick): `Swater' was set to `Ssnow_new'.

	* hydraulic.C (check_alist): New function.
	(load_syntax): Use it.

	* crop_sold.C (CropSoldSyntax): Removed `Stem'.

1999-07-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_heat.C (calculate_heat_flux): New member function.
	(tick): Call it.
	(T_top_old, T_top_bottom): New member.
	(tick): Set them.
	(q): New member.
	(output): Log it.
	(load_syntax): Define it.

1999-06-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (NitrogenUptake): At least CrNCnt if !enable_N_stress.

	* Version 0.82 released.

1999-06-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Crop Photosynthesis"): Added Soil CO2.

1999-06-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.81 released.

1999-06-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Soil Heat Balance"): New log parameterization.
	("Soil Temperature"): Use `table' instead of `table1'.
	("N Balance"): Ditto.

	* select_index.C: New model.
	* Makefile (COMPONENTS): Add it.

1999-06-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_heat.C: Implemented freezing and thawing.

	* column_std.C (tick): Tick heat before water.

	* soil.h (heat_conductivity, heat_capacity): Change dimension.
	* horizon.C: Update provider.
	* soil_heat.C (tick): Update caller.
	* snow.C (tick): Update caller.
	* pt_pmsw.C (tick): Update caller.
	
	* soil.h (heat_conductivity, heat_capacity): Remove default value.

	* horizon.C (heat_conductivity): Fix formula.

1999-06-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.C, soil_water.h (add_to_sink): Use `Geometry' instead
	of `Soil'.
	(X_ice_): Renamed from `Xi'.
	(h_ice_, S_ice): New data member.
	(freeze, Theta, K, K, h_ice, X_ice): New member funciton. 	
	* soil_water.C (clear, tick, mix, swap, check, output,
	MaxExfiltration, put_h, load_syntax, initialize): Use them.
	* soil.h, soil.C (K, Theta): Take extra `h_ice' parameter.  Outline.
	* soil.h: (Cw1): Updated caller.
	* surface.C (albedo): Update caller.  
	* denitrification.C (tick): Update caller.
	* snow.C (tick): Update caller.  Also call K with h instead of Theta.
	* macro.h, macro_std.C, macro_none.C (tick): Update caller.
	* uzmodel.h, uznone.C, uzlr.C (tick): Update caller.
	* uzricard.C: (tick, richards): Update caller.
	* crop_sold.C, crop_old.C, crop_std.C (PotentialWaterUptake):
	Updated caller.

1999-06-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pt_std.C (tick): Outcommented new arguments.

	* pt_pmsw.C (PT_PMSW::PT_PMSW): Reordered some initializations to
	match declaration order.

	* pt_pmsw.C, pt_std.C, pt.h, bioclimate_std.C: Merged in pvdk changes.
	
1999-06-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.80 released.

1999-06-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_select.h, log_select.C (select.h, condition.h): Moved to
	header file in order to ensure proper initialization order in
	derived classes. 

	* Version 0.79 released.

1999-06-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Crop Photosynthesis"): New log model.

	* Version 0.78 released.

1999-06-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (INTERFACES): Moved log_extern.C to here.
	(COMPONENTS): From here.

	* Version 0.77 released.

1999-06-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cdaisy.h (daisy_log_type): New type.
	* cdaisy.C, cdaisy.h (daisy_log_lookup): New function.
	(daisy_log_get_number): Ditto.
	(daisy_log_get_name): Ditto.
	(daisy_log_get_array): Ditto.

	* log_extern.C: New log model.
	* Makefile (COMPONENTS): Added it.

	* lib/Makefile (MSHE): New macro.
	(daisy-lib.zip): Use it.
	(cvs): Ditto.

1999-06-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.76 released.

1999-06-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (initialize): Fixed units.

1999-06-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (initialize): Initialize am.

	* am.C (initialize): Root depth should be negative.
	(check_root): New check.
	(AM_Syntax): Add it.

1999-06-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_content.C, select_interval.C, select_flux.C,
	select_date.C, select_array.C, select_number.C: New models. 
	* Makefile (COMPONENTS): Added them.

1999-05-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C: New model.
	* Makefile (COMPONENTS): Added it.

1999-05-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table1.C: Ranamed it...
	* log_table.C: from this.
	* Makefile (COMPONENTS): Ditto.

	* Makefile (INTERFACES): Moved `log_select.C' to here.
	(COMPONENTS): From here.
	
1999-05-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.C, select.h: New component.
	* Makefile (INTERFACES): Add it.
	* log_select.C: New model.
	* Makefile (COMPONENTS): Add it.

1999-05-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.75 released.

1999-05-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log.h (output): No longer takes an `log_only' parameter.
	* all: Updated callers.
	* log.h (output): No longer takes `filter' parameter.
	* all: Updated callers.
	* log_file.C, filter.h, filter.C, filter_all.C, filter_array.C,
	filter_checkpoint.C, filter_none.C, filter_some.C: Removed.
	* Makefile: Updated.
	
	* Version 0.74 released.

1999-05-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* harvest.h: Made all data members public.
	* log_harvest.C: New log model.

	* log_table.C (LogEntry::initialize): New function.
	(string_map): New type.
	(<map>): New include.
	(LogTableSyntax): Added `set' attribute, plus check function.
	(LogTable): Use it.
	* lib/log.dai: Use it.

	* action_while.C (check): Fix const error.

	* minimanager.h (check): Add const to `Daisy' argument.

1999-04-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt/reference/introduction.tex (subsection{Management}): Use
	`activity' in example, instead of `cond'.

	* Version 0.73 released.

1999-04-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* condition_time.C (ConditionBeforeMMDD, ConditionAfterMMDD): new
	conditions. 

1999-04-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_while.C: New model.

1999-04-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* condition_time.C (ConditionMMDD): New condition.
	* action_wait.C: New model.
	* Makefile (COMPONENTS): Added it.

1999-04-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action.h, action.C (done): New virtual member.
	* action_activity.C: New model.
	* Makefile (COMPONENTS): Added it.

1999-04-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* condition.C, condition_crop.C, condition_daisy.C,
	condition_logic.C, condition_soil.C, condition_time.C (output):
	Nem vitual member function.
	* action_lisp.C: Updated caller.

1999-04-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (NitrogenUptake): Update all at 23:00 not 0:00.
	(tick): Do daily stuff at 23:00 not 0:00.

	* daisy.C (tick): Update hour _after_ logging.

	* weather_hourly.C (WeatherHourlySyntax): Made `file' ordered.

1999-04-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action.h (output): New virtual member function.
	(name) Made public.
	(alist) new member.
	(Action) Constructor takes alist argument.
	* action.C, action_divide.C, action_fertilize.C, action_harvest.C,
	action_irrigate.C, action_lisp.C, action_merge.C, action_sow.C,
	action_spray.C, action_stop.C, action_tillage.C, action_with.C:
	Updated callers.


1999-04-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Merged SH changes.

1999-04-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (NetProduction): More numeric robust handling of C_foli.

1999-03-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Ran ispell on descriptions.

1999-03-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.72 released.

1999-03-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* solute.C (tick): Let surface solute to follow water in macropores.
	* mactrans_std.C (tick): Handle this case.

	* surface.C (accept_top): Allow `accept_top' to be called multiple
	times. 

	* uzlr.C (tick): Fix q for oversaturated soil.

1999-03-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* average.h, average.C: New components.
	* average_arithmetic.C, average_harmonic.C, average_geometric.C:
	New models.
	* Makefile (COMPONENTS, INTERFACES): Add them.
	* uzricard.C (K_average): New member.
	* uzmodel.C, uzmodel.h, uzricard.C (has_macropores): New member.
	* soil_water.C: Call it.

	* lib/log.dai ("Preferential NH4 Transport", 
	"Preferential NO3 Transport", "Preferential Water Flux"): 
	Now log file formats.

	* soil_water.C, soil_water.h: Added `S_p' log variable.

1999-03-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* mactrans.h, mactrans.C: New component.
	* mactrans_std.C: New model.
	* Makefile (COMPONENTS, INTERFACES): Add them.
	* solute.h, solute.C: Add `mactrans' and `J_p' members.
	* transport_cd.C, transport_convection.C, transport_none.C,
	transport.h, solute.C: Move `J' to `Solute'.
	* lib/log.dai ("N Balance", "Soil Chemicals"): Updated logs.
	
	* macro_std.C: New file.

1999-03-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (filecount): New target.

	* soil_water.C, soil_water.h: Added `macro' and `q_p' members.

1999-03-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* macro.C, macro.h: New component.
	* macro_none.C: New model.
	* Makefile (COMPONENTS, INTERFACES): Add them.

1999-03-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.C (check): Fixed spelling error in error message.

	* lib/beet-old.dai ("Beet; V1"): Renamed from `Beet'.

	* lib/Makefile (NEWCROPS): Removed `cutgrass'.

	* lib/crop.dai (file): Removed cutgrass.

	* field.C (restrict): Fixed spelling error in message string.

	* soil_heat.C (initialize): Don't assert that T has the right size
	here.

	* parser_file.C (load_list): Better error message for unknown
	attributes. 

1999-02-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.71 released.

1999-02-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* daisy.C, daisy.h (activate_output): New member.
	(tick_logs): Use it.

	* condition_logic.C (ConditionFalse, ConditionTrue): New conditions.

1999-02-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (Implementation::Implementation): Fix index
	error in smb initialization.

1999-02-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.h (Syntax::Syntax): Don't take `check_fun' argument.
	* all: Updated callers.

	* Version 0.70 released.

1999-02-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_old.C, crop_sold.C (molWeightCH2O, molWeightCO2): Removed.

	* syntax.h (add): Removed compatibility variants.
	* all: Updated callers.
	
	* crop_old.C: Removed `Q10' parameter.
	* crop_sold.C: Ditto.

1999-02-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C: Made DS_start_fixate a state variable.

	* crop_old.C, crop_sold.C: Removed `LeafPhotPar::Qeff' and
	`LeafPhotPar::LFm'.
	(CanopyPhotosynthesis): Removed.

	* crop_old.C, crop_sold.C, crop_std.C: Added dimensions and
	descriptions.

1999-02-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C: SH changes.

	* tortuosity_linear.C, tortuosity_M_Q.C: Added dimensions and
	descriptions.
	* uzlr.C, uznone.C, uzricard.C: Ditto.
	* weather.C, weather_file.C, weather_hourly.C, weather_none.C,
	weather_simple.C: Ditto.
	* filter_all.C, filter_array.C, filter_checkpoint.C,
	filter_none.C, filter_some.C: Ditto.

1999-02-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* net_radiation.C (NetRadiationBrunt): Made `a' and `b'
	parameters. 

	* net_radiation.C (load_syntax): Don't choose brunt here.
	* pet_PM.C (PetPMSyntax): Explicitly choose `brunt'.
	* weather.C (RefNetRadiation): Ditto.

	* condition_soil.C, condition_logic.C, condition_time.C,
	condition_crop.C, condition_daisy.C: Added dimensions and
	descriptions. 
	* document_LaTeX.C: Ditto.
	* groundwater_file.C, groundwater_static.C: Ditto.
	* horizon.C: Ditto.
	* hydraulic.C, hydraulic_B_BaC.C, hydraulic_B_BaC_Bimodal.C,
	hydraulic_B_C.C, hydraulic_B_vG.C, hydraulic_M_BaC.C,
	hydraulic_M_BaC_Bimodal.C, hydraulic_M_C.C, hydraulic_M_vG.C,
	hydraulic_mod_C.C, hydraulic_old.C, hydraulic_old2.C,
	hydraulic_yolo.C: Ditto.
	* log_checkpoint.C, log_file.C, log_table.C: Ditto.
	* net_radiation.C: Ditto.
	* nitrogen_soil.C, nitrogen_solute.C: Ditto.
	* parser_file.C: Ditto.
	* pet.C, pet_PM.C, pet_makkink.C, pet_weather.C: Ditto.
	* printer_file.C: Ditto.
	* pt.C, pt_pmsw.C, pt_std.C: Ditto.
	* transport_cd.C, transport_convection.C, transport_none.C: Ditto. 


1999-02-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* daisy.C (load_syntax): Made `harvest' a state parameter.
	* harvest.C (load_syntax): Made all members state parameters.

1999-02-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* daisy.C, denitrification.C, organic_matter.C, soil.C,
	soil_chemicals.C, soil_heat.C, soil_NH4.C, soil_NO3.C,
	soil_water.C, surface.C, vegetation.C: Made them submodels and
	added descriptions and dimensions.

	* geometry.C, geometry.h (add_layer): Take `dimension' and
	`description' parameters.
	(initialize_layer): Multiply value with layer height.
	* soil_water.C, soil_heat.C, solute.C: Updated callers.

	* solute.C: Added dimensions and descripions.

	* solute.C: Split `ppm' in `soil_ppm' and `solute_ppm'.

1999-02-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* document_LaTeX.C (print_quoted): More advanced superscript
	handling. 

	* soil_chemical.C (load_syntax): Made it a submodel.
	Added dimensions and descriptions.
	
	* document.C (print_submodel): Print log variables separately.
	* document_LaTeX.C, document.h (print_log_header,
	print_log_trailer):  New member functions.
	(print_submodel_entry): Don't print category line for log
	variables. 
	(print_entry_category): Removed `printed_category_line' function
	parameter. 

	* weather.C (deposit, load_syntax): Changed dimensions for deposit. 

	* adsorption_linear.C, adsorption_freundlich.C,
	adsorption_langmuir.C: Use `K_OC' instead of `K_humus'.

	* crop_std.C, lib/*.dai: SH update.
	
	* cdaisy.C, chdaisy.h (daisy_column_put_surface_chemical,
	daisy_column_get_surface_chemical): New member functions.
	* column_std.C, column.h (put_surface_chemical,
	get_surface_chemical): New member functions.
	* bioclimate_std.C, bioclimate.h (put_surface_chemical,
	get_surface_chemical): New member functions.
	* chemicals.C, chemicals.h (set): New member function.

	* bioclimate_std.C (chemicals_can_enter_soil): New parameter.

1999-02-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.69 released.

1999-02-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (output): Fix calculation of total C and N.

	* lib/log.dai ("Total Soil Content"): Added buffer C and N.

	* transport_cd.C (tick): Add `S_top' to J[0].

	* lib/log.dai ("Crop Production"): Added `water_stress' and
	`nitrogen_stress', output at hour 12.

1999-02-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (Buffer::tick): Added assertions.

	* Version 0.68 released.

1999-02-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* library.C (add_derived): Add superclass here.
	* parser_file.C (add_derived): Not here.

1999-02-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* snow.C (load_syntax): Made it a submodel, and added dimensions
	and descriptions.
	(load_syntax): Changed default for `Psa' from 200 to 5/24, and
	`fsa' from 0.5 to 0.9.

	* bioclimate_std.C (BioclimateStandardSyntax): Added points to
	description.
	* chemicals.C (add_syntax, load_syntax): Made it a submodel.

	* horizon.C, horizon.h, soil.h (humus): New function.
	* adsorption_linear.C (C_to_M): Use it.
	* (K_humus): New parameter.
	* (test_alist): New function.
	* adsorption_freundlich.C: Ditto.
	* adsorption_langmuir.C: Ditto.

	* adsorption_langmuir.C: Added descriptions.
	* adsorption_freundlich.C: Ditto.
	* adsorption_linear.C: Ditto.
	* adsorption_vS_S.C: Ditto.
	* adsorption_none.C: Ditto.

	* adsorption_linear.C (C_to_M, M_to_C): Don't multiply dry bulk
	density with (1 - porosity).

1999-02-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_merge.C (ActionMergeSyntax): Added description.

	* submodel.C, submodel.h: New files.
	* Makefile (INTERFACES): Add them.
	* im.C (im_submodel): Use it.

	* column.h (size): New member.
	* action_merge.C, action_divide.C, field.h, field.C: Use it.
	* column.C, column.h (load_syntax): New function.
	* column_std.C (ColumnStandardSyntax): Call it.
	* column.C, column.h (output): Made it impure..

1999-02-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Added descriptions of all components.

1999-02-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.67 released.

1999-02-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* solute.h (output): Made virtual.
	* soil_chemical.h, soil_chemical.C (output): New function.
	* solute.h (initialize): Made virtual.
	* soil_chemical.h, soil_chemical.C (initialize): New function.
	* soil_water.h, soil_water.C (S): New public member function.
	(S_) Renamed from `S'.
	* soil_chemical.h, soil_chemical.C (uptake): New function.
	(uptaken) New member.
	* soil_chemicals.C (tick): Call it.

	* lib/log.dai ("Soil Chemicals"): New log model.
	("Surface Chemicals"): Log amount, not "*".

	* printer_file.C (print_entry): Use Syntax::default_alist instead
	og old kludge with singleton alist.

	* am.C, im.C, im.h: Add descriptions.
	Changed syntax for `organic' and `mineral' fertilizer.
	* lib/fertilizer.dai: Updated to new syntax.

1999-01-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* librarian.h, library.C, library.h (descriptions): Add option to 
	describe libraries. 

	* action_lisp.C (ActionCond, clauses, ActionLispSyntax): Allow
	list of actions in `cond'.

	* syntax.C, syntax.h (dump): Removed.
	* library.C, library.h (dump): Removed.
	* common.C: Don't call them.
	
1999-01-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (CropStandardSyntax): `10.0' instead of `10'.

	* document.C, document.h: New component.
	* docuemnt_LaTeX.C, document_LaTeX.h: New model.
	* common.C: Use it.

	* Version 0.66 released.

1999-01-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation.C (reset_canopy_structure): Allow up to 1% divergence
	between `height' and `HvsLAI (LAI)'.

1999-01-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* geometry.C (interval_border): Fix bug which always gave the last
	node point.

	* parser_file.C (load_derived): Skip to end if superclass is unknown.

	* action_harvest.C, action_sow.C (doIt): Indent message.
	* crop_std.C (tick): Indent DS messages.

1999-01-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_with.C (doIt): Fix bug which prevented the restriction
	from taking effect.

	* Version 0.65 released.

1999-01-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzrichard.C (richard): Update `Theta_new' below groundwater
	according to `h_new', not `h'.
	(richard): Fix one-off error for pressure button.
	(richard): Move update of Theta in groundwater.
	* soil_water.C (tick): Add it here instead.


1999-01-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* geometry.C (interval_plus, interval): Use `false' instead of 0
	in assertions. 

	* groundwater.C (load_syntax): New function.
	* groundwater_static.C (GroundwaterStaticSyntax): Call it.
	* groundwater.C (output): Log groundwater table.
	* groundwater_file.C: New file.
	* lib/log.dai ("Groundwater"): New log.

1999-01-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.64 released.

1999-01-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("PMSW"): Now log definition.

1999-01-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_mod_C.C (M): Fix for `h > h_b'.

1999-01-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzmodel.h, uzlr.C, uzrichard.C, uznone.C (tick): Make `top' and
	`bottom' const. 
	* soil_water.C (tick): Update `surface' and `groundwater' here
	instead.
	* uzmodel.h, uzlr.C, uzrichard.C, uznone.C, surface.C
	(flux_top_on, flux_top_off): Made them const.
	* surface.C (flux): Made it mutable.

1999-01-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.63 released.

1999-01-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* event.C: Give crop a name.

	* eventqueue.C: Merged JRI changes.

	* event.C: Merged with JRI version.

	* action_irrigate.C (ActionIrrigateSyntax): Add dimensions and
	descriptions. 

1999-01-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Assume working exception handling.

	* Makefile: Removed support for gcc 2.7.2.

1999-01-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.62 released.

1999-01-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (load): Allow empty dai files.

	* Version 0.61 released.

1999-01-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/mini.dai ("mini"): Don't set parameters, use default values.

	* soil_water.C (load_syntax): The model implementing Richards
	Equation is named `richards', not `richard'.

	* syntax.C (check): Check that element is in a library, before
	querying for its syntax.

1999-01-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.60 released.

1999-01-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C: SH Update.
	
	* cdaisy.C (daisy_daisy_run): Catch exceptions.
	(daisy_daisy_tick): Ditto.
	(daisy_daisy_tick_action): Ditto.
	(daisy_daisy_tick_weather): Ditto.
	(daisy_daisy_tick_columns): Ditto.
	(daisy_daisy_tick_column): Ditto.
	(daisy_daisy_tick_logs): Ditto.
	(daisy_daisy_tick_time): Ditto.

	* cmain.c (main): Support `-v'.

1999-01-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.59 released.

1999-01-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_std.C (ColumnStandardSyntax): Added more default values.
	* organic_matter.C (load_syntax): Ditto.
	* denitrification.C (load_syntax): Ditto.

	* Version 0.58 released.

1999-01-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log.h, log.C, log_alist.C (open_alist, close_alist): New function.
	* soil_chemicals.C (output): Use them.

	* Makefile (TEXT): Added `tlink32.ini'.
	(daisy-src.zip): Removed `tlink32.ini'.

	* action_spray.C (ActionSpraySyntax): Call `check_alist'.

	* chemical_std.C, chemical.h (diffusion_coefficient, solute_alist,
	decompose_rate, decompose_heat_factor, decompose_water_factor,
	decompose_CO2_factor): New function.
	* chemicals.C, chemicals.h (lookup, find_missing): New functions.
	* soil_chemical.C, soil_chemical.h: New module.
	* soil_chemicals.C, soil_chemicals.h: New module.
	* Makefile (INTERFACES): Add them.
	* column_std.C: Add `SoilChemicals' submodule.
	* chemicals.C, chemicals.h (amount): New public member function.
	* bioclimate_std.C, bioclimate.h (chemicals_down): New virtual
	member function.
	* soil_NH4.C, soil_NH4.h: Cleanup.
	* soil_NO3.C, soil_NO3.h: Ditto.

1998-12-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.57 released.

1998-12-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* field.C (divide): Mark clones objects.
	* log_checkpoint.C (done): Print cloned objects.

	* log_checkpoint.C (LogCheckpointSyntax): Don't assume `finished'
	has been added to the `condition' library yet.

	* weather.C (deposit): Added assertions.
	* column_std.C (irrigate_top): Ditto.
	(irrigate_surface): Ditto.
	(fertilize): Ditto.

1998-12-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_merge.C, action_divide.C: New files.
	* Makefile (COMPONENTS): Add them.
	* field.C, field.h (divide, merge): New functions.
	* log_clone.C, log_clone.C: New files.
	* Makefile (INTERFACES): Add them.

	* log_alist.C, log_alist.h: New files.
	* Makefile (INTERFACES): Add them.
	* log_checkpoint.C: Use them.

	* Version 0.56 released.

1998-12-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_checkpoint.C (check): Added wrappers for more Filter::check
	functions to shut up BCC.

	* am.C: Add another explicit template instanciation for BCC.

	* Version 0.55 released.

1998-12-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (output, load_syntax, OM): Make `initial_fraction' a state
	variable. 
	(get_initial_C_per_N): New function.
	(OM): Use it.

1998-12-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C, crop_old.C, crop_sold.C, crop.h (initialize): Take
	`organic_matter' parameter.
	* vegetation.h, vegetation.C, column_std.C: Update callers.

	* daisy.C (tick): Tick hour before logs.

	* Version 0.54 released.

1998-12-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (initialize): Call `NitContent'.
	* soil_water.C (initialize): Also initialize `h_old' and `Theta_old_'.
	Fix error when `h' is specified.
	
	* field.C (Implementation): Use `map_create'.

	* vegetation.C, vegetation.h (initialize): New function.
	* column_std.C (initialize): Call it.

	* log.h (open_entry): Take alist argument.
	* log_checkpoint.C, log_file.C, log_table.C, field.C: Update callers.

	* log_checkpoint.C: Implemented.

1998-12-27  Per Abrahamsen  <abraham@dina.kvl.dk>
	
	* am.C, am.h: Use `Librarian'.
	* organic_matter.C: Update caller.
	* action_fertilize.C: Ditto.
	* event.C (Do_It): Ditto.

	* am.C, am.h (AM, create, initialize).  Split `AM::initialize'
	from `AM::AM', and update `AM::create' to call it.

	* crop_std.C (CropStandardSyntax): Added missing `LAImRat'
	parameter to syntax. 

	* am.C (AM::Implementation::Lock::load_syntax): New function.
	(AM_init): Use it.

	* am.C, am.h (AM, create): Remove `Time' argument.
	* column_std.C, column.h (fertilize): Update callers.
	* field.C, field.h (fertilize): Ditto.
	* action_fertilize.C: Ditto.
	* event.C (Do_It): Ditto.

	* am.C (AM_init): Converted some `Syntax::Const' to
	`Syntax::State' in order to allow logging them.

	* surface.h, surface.C (Implementation): Store internal details
	here. 

	* nrutil.C: Cleanup unused argument warnings.

1998-12-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Checpoint related changes.

	* syntax.h (Syntax::category): Split `Syntax::Optional' into
	`Syntax::OptionalState' and `Syntax::OptionalConst'.
	* all: Updated callers.
	
	* condition_daisy.C (struct ConditionFinished): New condition.

	* Version 0.53 released.

	* field.C: Various Borland C fixes.
	
1998-12-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.52 released.

	* frame.h, frame.C: Removed.
	* field.h, field.C: Added.
	* all: Updated.

	* Version 0.51 released.

1998-12-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C: Make it possible to log strings.

1998-12-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_std.C, bioclimate.h (harvest_chemicals): New
	function.
	* crop_std.C (harvest): Call it. 
	* vegetation.h, vegetation.C (harvest): New bioclamate argument.
	* crop.h, crop_std.C, crop_old.C, crop_sold.C (harvest): Pass it.
	* column_std.C: Pass it.

	* harvest.C, harvest.h: Add chemicals to harvest.

	* chemicals.C, chemicals.h (cleanup): New function.
	* bioclimate_std.C (ChemicalDistribution): Call it.

	* chemicals.C (output): Don't log nothing.

	* Version 0.50 released.

1998-12-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_std.C (tick): Call `ChemicalDistribution'.

1998-12-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.49 released.

1998-12-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* nrutil.C, nrutil.h: New files.

	* Makefile (INTERFACES): Add them.
	* pt_pmsw.C: New model.
	* Makefile (COMPONENTS): Add it.

	* chemicals.C, chemicals.h: New files.
	* Makefile (INTERFACES): Add them.
	* bioclimate_std.C: Use them.
	* action_spray.C: New file.
	* Makefile (COMPONENTS): Add it.
	* column.h (Column::spray): New pure virtual member.
	* column_std.C (ColumnStandard::spray): Implement it.
	* bioclimate.h (Bioclimate::spray): New pure virtual member.
	* bioclimate_std.C (BioclimateStandard::spray): Implement it.

	* log.h (output_submodule): Allow `log_only' argument.

1998-12-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* snow.C, snow.h (storage): Renamed from `get_storage'.
	* bioclimate_std.C (get_snow_storage): Update caller.
	* snow.C, snow.h (evaporation, temperature, precipitation): Made
	const. 

	* bioclimate_std.C: Renamed `crops' to `vegetation'.

	* geometry.C, geometry.h (interval_border): New member function.
	* log_table.C (LogEntry::flux_at): New parameter.
	* log_table.C (LogEntry::content_at): Renamed from `at'.

	* Version 0.48 released.

1998-12-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon.C (check_alist): Check that `humus > 0'.
	(load_syntax): Register it.

1998-12-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.C (add_check): New functions.
	(Implementation): Use lists of check functions.
	* geometry.C (load_syntax, check_alist): Use it.
	* soil.C (load_syntax, check_alist): Ditto.
	* organic_matter.C (load_syntax, check_alist): Ditto.
	* column_std.C (ColumnStandardSyntax): Call them.

	* Version 0.47 released.

1998-12-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.h (add_submodule_sequence): Allocate alist on
	stack instead of heap.
	(add_submodule): Ditto.
	* syntax.C (add): Copy alist to heap.

	* hydraulic_B_BaC_Bimodal.C (Theta): Check for `h > 0'.
	* hydraulic_M_BaC_Bimodal.C (Theta): Ditto.

	* Version 0.46 released.

1998-12-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzrichard.C (richard): Don't try for convergence if tridia gives
	absurd results.  Set down the time step instead.

	* lib/log.dai: Update logs for new bioclimate and vegetation
	models. 

1998-12-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* csmp.C (operator): Added assertions.

1998-12-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation.C, vegetation.h: New files.  Class `Vegetation'
	replaces `CropList' from `crop.h'.
	* bioclimate.h, bioclimate_std.C, column_std.C, pet.h, pet.C,
	pet_PM.C, pet_makkink.C, pet_weather.C, pt.h, pt_std.C:
	Update callers.  
	
	* Version 0.45 released.

1998-12-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C: Import `Filter::check' functions.
	* filter_none.C: Ditto.
	* filter_all.C: Ditto.

	* weather_file.C (tick): Make `end' an `int' instead of `char'.

	* soil.C, soil.h, geometry.C, geometry.h (check_alist): Renamed
	from `check'. 

	* common.C (Options): Give up on parser errors.

	* pmain.C: Support hourly values.

	* crop_std.C (harvest): Remove debug message.

	* action_harvest.C (struct ActionHarvest): Fix outout message.

1998-12-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Merged SH changes.
	* geometry.C (check): Add static check for zplus.
	* soil.C (check): Call it.  Add static check for horizon.
	* column_std.C (ColumnStandardSyntax): Call it.

	* bioclimate_std.C, bioclimate_new.C: Removed the original
	`bioclimate_std.C', and replaced it with `bioclimate_new.C'. 
	* bioclimate_PM.C: Removed.

	* crop.C (CropList::cover): New function.
	* bioclimate_new.C (CanopyStructure): Use it.

	* pt.h, pt.C: New component.
	* Makefile (INTERFACES): Added it.
	* pt_std.C: New model.
	* Makefile (COMPONENTS): Added it.
	* bioclimate_new.C: Added it.

1998-12-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* surface.C (tick): Renamed from `evaporation'.
	(exfiltration): Renamed from `get_exfiltration'.
	(evap_soil_surface): Renamed from `get_evap_soil_surface'.
	(evap_pond): New function.
	* bioclimate_PM.C, bioclimate_std.C (WaterDistribution): Ditto. 
	* column_std.C: Ditto.
	* surface.C (evap_pond): New function.

	* column.h (irrigate_top, irrigate_surface): Replace `irrigate'. 
	* column_std.C (irrigate_top, irrigate_surface): Ditto.
	* bioclimate.h (irrigate_top, irrigate_surface): Ditto.
	* bioclimate_PM.C (irrigate_top, irrigate_surface): Ditto.
	* bioclimate_std.C (irrigate_top, irrigate_surface): Ditto.
	* action_irrigate.C: Update callers.
	* event.C (IrrigateEvent::Do_It): Ditto.

1998-12-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pet_PM.C: New model.
	* pet_weather.C: New model.

	* bioclimate.C, bioclimate.h (CanopyResistance,
	RefCanopyResistance, ZeroPlaneDisplacement,
	RoughnessHeight_Momentum, RoughnessHeight_Heat,
	AerodynamicResistance, RefAerodynamicResistance): Added FAO
	utility functions. 
	* weather.C, weather.h (LatentHeatVaporization,
	PsychrometricConstant, AtmosphericPressure, AirDensity,
	SaturationVapourPressure, SlopeVapourPressureCurve,
	CloudinessFactor_Arid, CloudinessFactor_Humid, RefNetRadiation):
	Ditto. 

	* net_radiation.C, net_radiation.h: new component.

1998-11-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop.C, crop.h (Crop::albedo): New virtual member function.

	* surface.C, surface.h, soil.C, soil.h: Moved `EpFactor' and
	`EpInterchange' from soil.C to surface.C.

1998-11-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.44 released.

1998-11-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* options.C, options.h, main.C:  Moved option parsing from main.C
	to options.h.

1998-11-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (CropStandardSyntax): Default SpRtLength was integer,
	should be floating point.

	* Version 0.43 released.

1998-11-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/Makefile (DAISY): Removed `crop-old.dai'.

	* All: SH update.

1998-11-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.42 released.

1998-11-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (CropStandardSyntax): Fix default for `SpRtLength'. 

	* Version 0.41 released.

	* crop_std.C (CropStandardSyntax): Add description and default for
	`SpRtLength'. 
	(RootDensity): Multiply SpRtLength with 100 instead of 10.

1998-11-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.40 released.

1998-11-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Crop Production"): Output N for each crop part.

1998-11-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/mini.dai: New file.
	* lib/Makefile (DAISY): Add it.
	* lib/Makefile (stdref.dai): New target.

	* pet_makkink.C: New file.
	* Makefile (COMPONENTS): Add it.

	* pet.C, pet.h: New files.
	* Makefile (INTERFACES): Add them.

1998-11-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.39 released.

1998-11-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/sugarbeet.dai: Remamed from sbeet.dai.

	* Version 0.38 released.

	* lib/*.dai: Renamed crops.

1998-11-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.37 released.

1998-11-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (CanopyStructure): Insert checks.

	* bioclimate_new.C (CanopyStructure): Only call if LAI > 0.0.
	* bioclimate_std.C (RadiationDistribution): Ditto.

	* Version 0.36 released.

1998-11-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (CropStandardSyntax): Add `description' parameter.

	* Version 0.35 released.

1998-11-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/grass2.dai ("Grass, DS=2"): New file.

	* lib/Makefile (NEWCROPS): Added `crass2.dai'

	* Makefile (INTERFACES): Add `common.C' here.
	(HEADERS): Remove `common.h' here.

	* common.C: New file.
	(_assert): New function.

1998-11-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_std.C (WaterDistribution): Reset irrogation.

	* action_irrigate.C: Split into `irrogate_top' and
	`irrigate_surface'. 

	* organic_matter.C (load_syntax): Use new form for default alist
	in sequence.

	* crop_std.C: Merged SH's cleanup changes.

	* options.h, options.C (Options::message, Options::warning,
	Options::error): New static member functions.
	* all: Use them.

1998-11-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.34 released.

1998-11-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C: Merged SH's changes for continues calculation of N
	in crop parts.

1998-11-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Put default values for members of the alist sequence in the
	syntax. 

	* Version 0.33 released.

1998-11-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (Parameters::CrpNPar::fixate_factor): New parameter.
	(NitrogenUptake): Use it.

	* pmain.C (redraw): No labels outside axis.

	* bioclimate_std.C (WaterDistribution): Don't whine about small
	negative throughfall.

1998-11-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_std.C (check): Deleted.
	(ColumnStandardSyntax): Add OrganicMatter::check to its syntax.

	* Makefile (COMPILE): Don't warn about uninitialized.

	* uzrichard.C (richard): Allow cw2 to be zero (undo 1998-10-30
	change). 

	* hydraulic_M_BaC_Bimodal.C: New file.
	* hydraulic_B_BaC_Bimodal.C: New file.
	* Makefile (COMPONENTS): Add them.

	* Version 0.32 released.

1998-11-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.h (SoilWater::reserve): New member.
	* soil_water.C (load_syntax): Define it.
	(SoilWater): Initialize it.
	(tick): Use it.

	* uzrichard.C (q_darcy): Throw an exception instead of calling
	assert when checking for enough nodes around 3/4 depth.

1998-11-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_B_BaC.C (Cw2): Wrong expression.
	* hydraulic_M_BaC.C (Cw2): Ditto.

1998-11-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Use `char*' instead of `runtime_error' for exceptions.

	* time.C (valid): Don't specify default parameter here.

	* crop_std.C (NetProduction): Use LAImRat to kill leafs.

1998-11-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pmain.C: New `limits' window to set axis limits.

	* time.C (valid): New static member function.

	* cmain.c (main): Use `exit' instead of `return' from `main'.

1998-10-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzrichard.C (richard): Fix pressure top connection.
	(richard): Make cw2 at least 1e-5, works better in saturated
	conditions that way.

	* surface.C (accept_top): Always accept exfiltration.
	Warn only for negative NO3 or NH4.

1998-10-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile: (daisy-hdr.zip): Removed.
	(dist): Don't use it.

1998-10-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (dist): Also copy `main.C' and `cmain.c' to ftp.

1998-10-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.31 released.

1998-10-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (daisy-hdr.zip): New target.
	(dist): Use it.

1998-10-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.030 released.

1998-10-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* solute.C (initialize): Fix initialization from ppm.

	* syntax.h (check_list_fun): New typedef.
	* syntax.C (check): Use it.
	* geometry.C (add): Check that the bottom is below the top.
	(check_layers): New function.
	(add_layer): Use it.

	* adsorption_vS_S.C, adsorption_linear.C, adsorption_langmuir.C,
	* adsorption_freundlich.C (C_to_M): Use `dry_bulk_density' instead
	of `rho_mineral'.

	* parser_file.C (load_list): Don't crash if we are overwriting an
	alist sequence.

1998-10-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pmain.C: New `monochrome' view option.

1998-10-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon.C (Implementation): Fix dry_bulk_density to take
	porosity into account.

	* organic_matter.C (Implementation): Check for `!='
	Syntax::Singleton instead of `==' Syntax::Sequence.

	* crop_std.C (AssimilatePartitioning): Don't allow 
	0.0 < f_SOrg < 1e-5. 
	(harvest): Only partition N to SOrg iff WSorg > 0.1 g/m².

1998-10-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_file.C (print): Use array delete.

1998-10-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pmain.C: Make widgets members when possible, to ensure they are
	deleted properly.

	* uzrichard.C (UZRichardSyntax): Demand 10 time better convergense.

1998-10-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (CropFun): Removed typedef.

1998-10-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.h (Theta_left): New member function.

	* crop_std.C (PotentialWaterUptake): Leave at least h_wp.

	* weather_file.C (tick): Don't eat last newline.

	* crop_std.C: Use average soil temperature.
	(DevelopmentStage): Use day_length + 1.0.
	(InitialLAI): Don't stop DS when there is too little WLeaf.

1998-10-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* daisy.C (load_syntax): Fix parameter for manager syntax.

	* nitrification_soil.C (tick): No negative nitrification.

1998-10-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pmain.C: New main file, a simple plot program.
	* gmain.C: New main file, a Daisy library browser.
	* Makefile: Add support for them.

	* time.h: Don't include "common.h".  This makes `time' a
	stand-alone module.

1998-09-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* daisy.C (load_syntax): Add descriptiobs.
	* harvest.C (load_syntax): Ditto.

	* syntax.C: Added `description' and `dimension' properties to
	syntax entries. 

1998-09-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* alist.C (size): Use reference counting.
	* crop_std.C (CropStandardSyntax): Add alists after filling them.
	* crop_sold.C (CropSoldSyntax): Ditto.
	* crop_old.C (CropOldSyntax): Ditto.

	* syntax.C (entries): new function.

1998-09-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* mathlib.C: No implicit int in egcs 1.1.

1998-09-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_file.C (tick): Don't "use >> char"; it works differently
	on BCC and GCC.

	* weather_hourly.C: Keep track of number of values we are
	averaging over when accumulating, to deal less bad with missing
	values. 

	* main.C (main): Add exception handling.

1998-09-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.029 released.

1998-09-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil.C (load_syntax): No default max rooting depth.

1998-08-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* surface.C (accept_top): Ignore tiny (< 1e-99) amounts.

1998-08-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_file.C (tick): Ensure we found the right day.
	Don't call `put' functions if we haven't read new data.

	* weather.C (Implementation): Initialize `daily_global_radiation'.

	* crop_std.C (Variables::Phenology): Add `day_lenght' and
	`partial_day_length'. 

1998-08-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.h (Weather::put_global_radiation): New function.
	* weather.C, weather_file.C, weather_hourly.C, weather_none.C: Use it.

	* chemical.C, chemical.h: New files.

1998-06-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* nitrification_soil.C (tick): Don't take the last.  More assertions.
	* nitrification_solute.C (tick): Ditto.

1998-06-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* transport_none.C (tick): Assert non-negative stuff left.

	* crop_old.C (SoluteUptake): Assert we didn't took more than there
	were left.

1998-06-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* adsorption_vS_S.C (class Adsorption_vS_S): Added units.
	(K_planar): New number.

	* crop_sold.C (SoluteUptake): Leave at least 1e-8 after uptake.
	* crop_old.C (SoluteUptake): Ditto.

1998-06-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* adsorption_vS_S.C (M_to_C): Move assertion inside else clause. 

1998-06-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (harvest): Really update height and LAI after
	harvest. 
	(Variables): New Canopy member `Offset'.

	* all: Renamed `adsorbtion' to `adsorption'.

1998-05-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (add): Expand array at end.
	(add): Don't multiply C with dz in each lay.
	(load_syntax, output): Add "N" log parameter.

	* om.C (add): Added assertions for mass conservation.
	* am.C (add, mix, swap, distribute): Ditto.

1998-05-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.028 released.

1998-05-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (load_syntax): Change default `min_AM_C' to 5
	kg C / Ha.

	* horizon.C (initialize): Use `to-1' instead of `to' for remaining
	elements. 

	* parser_file.C (load_list): Also count errors in nested files.

	* soil_heat.C (tick): Also calculate in groundwater.

	* organic_matter.C (load_syntax): Support `initial_SOM'.
	(Implementation::Implementation): Obey it.

	* transport_cd.C (tick): Complete 1998-05-19 change.

	* uznone.C (class UZNone): Don't check that asser_top succeded.

1998-05-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.027 released.

1998-05-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* main.C (main): Don't try to create Daisy if there were parser
	errors. 
	* cmain.c (main): Ditto.

	* surface.C (load_syntax): Define `total_matter_flux'.
	(accept_top): Use it.
	(Surface): Initialize it.
	* surface.h (class Surface): Define it.
	* uznone.C (tick): Call `top.accept_top'.
	* transport_cd.C (tick): Support stuff flux without water flux.

	* uzrichard.C (output): Mark output as log only.
	* uzlr.C (output): Ditto.

	* log_table.C: Added `dimension' and `description' parameters.

	* log_table.C (struct LogEntry): Made `from' and `to' non-const.
	(struct LogTable): Add `from' and `to' parameters.
	(LogTable::LogTable): Overwrite `from' and `to' for entries if
	specified. 
	(LogTableSyntax): Add `from' and `to' parameters.

	* log_table.C (LogEntry::full): New member.
	(LogEntry::full_value): Ditto.
	(LogEntry::output): Update it.
	(LogEntry::done): Print it.
	(LogEntry::LogEntry): Initialize it.
	(LogTableSyntax): Define it.

	* parser_file.C (load_derived): Add "error" type if the superclass
	is not found.
	(load_list): Check for "error" type.
	* syntax.C (check): Ditto.

	* condition_daisy.C: New file.
	* Makefile (COMPONENTS): Added.

1998-05-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.026 released.

1998-05-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon.C (heat_conductivity): Check that we are inside the
	arrayes. 
	(initialize): Fill the K arrays outside the res and sat
	boundaries. 

	* crop_sold.C, crop_old.C, crop_std.C (PotentialWaterUptake): No
	uptake at saturated conditions. 

1998-05-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.025 released.

1998-05-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.024 released.

1998-05-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C (struct LogEntry): New flag `accumulate'.

	* hydraulic_mod_C.C (M): Divide by b instead of multiplying by b.

	* soil.C (Cw2): Don't return 0, return a very small
	number instead.

	* crop_old.C: Add `H2OUpt' log parameter.
	(PotentialWaterUptake): Multiply with 2 pi.
	* crop_std.C (PotentialWaterUptake): Multiply with 2 pi.
	* crop_sold.C (PotentialWaterUptake):  Multiply with 2 pi.

1998-05-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.023 released.

1998-05-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_std.C (WaterDistribution): Check that `Through_fall'
	is non-negative.

1998-05-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C (struct LogEntry): Support `at' parameter.
	(LogTableSyntax): Define it.

	* Version 0.022 released.

1998-05-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_heat.C (tick): Limit size of calculation to unsaturated
	zone.  Don't trust groundwater module on this.

1998-05-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_std.C (WaterDistribution): Count snow and irrigation
	as part of net precipitation.

1998-05-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.021 released.

1998-05-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cdaisy.C: (daisy_daisy_get_column): Added some assertions.
	(daisy_column_put_water_pressure): Ditto.

	* cdaisy.h: Added more description.

1998-05-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uznone.C: New file.
	* Makefile (COMPONENTS): Added.

1998-05-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.020 released.

1998-05-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.C, soil_water.h (class SoilWater):  Added functions
	for communication with external model.
	* surface.C, surface.h: Ditto.
	* snow.C (get_h2o): Ditto.
	* bioclimate_std.C, bioclimate.C, bioclimate.h: Ditto.
	* colsumn_std.C, column.h: Ditto.  Call them.
	* cdaisy.C: Call them.

1998-04-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (get_number): Better error handling.
	(get_integer): Ditto.

1998-04-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cdaisy.C: Added dummies for unimplemented API functions.

1998-04-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.019 released.

1998-04-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cdaisy.C (daisy_alist_size_alist): Workaround for non-sequence
	alist value of an alist sequence kludge.

	* soil.C (load_syntax): Don't add alist element.

	* parser_file.C (Implementation::error_count): New member.
	(Implementation::error): Update it.
	(Implementation::Implementation): Initialize it.
	* parser.C, parser.h (Parser::error_count): New virtual function.
	* parser_file.C, parser_file.h (ParserFile::error_count): Define it.

1998-04-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* condition_time.C (struct ConditionHour): New condition.
	(struct ConditionMDay): Ditto.
	(struct ConditionYDay): Ditto.
	(struct ConditionMonth): Ditto.
	(struct ConditionYear): Ditto.
	(ConditionTimeSyntax::ConditionTimeSyntax) Add them.

1998-04-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cdaisy.C, cdaisy.h (daisy_weather_put_precipitation):
	Implement.  Fix formal parameter name.
	(daisy_weather_put_air_temperature): Ditto.
	(daisy_weather_put_precipitation): Ditto.

1998-04-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (tick): Move call to `DevelopmentStage' to after
	`NetProduction'. 
	(DevelopmentStage): No developmend when DS < 1 and there is no
	netto production of leafs.

	* crop_std.C (harvest): Don't harvest leafs on stub.

	* crop_std.C (Vernalization): Replace `DSLim1' and `DSLim2' with a
	single `DSLim' parameter.
	Made `Vernal' optional.
	(NetProduction): New parameter `Large_RtDR'.
	(RSR): New function and parameter.
	(AssimilatePartitioning): Use it.

	* lib/wwheat.dai (WinterWheat): Adjust.
	* lib/sbarley.dai (SpringBarley): Ditto.
	* lib/grass.dai (Grass): Ditto.

1998-04-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.018 released.

1998-04-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* geometry.C (add_layer): Use layer `end' instead of `size' for
	specifying layers.
	(initialize_layer): Ditto.

1998-03-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.017 released.

1998-03-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* daisy.C (load_syntax): Add "description".

	* Weather.C, weather.h, soil_heat.C (max_Ta_yday): Renamed from
	`omega_offset'. 

	* soil_heat.C (bottom): Expect `omega_offset' in days instead of
	radians. 

1998-03-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.016 released.

1998-03-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_PM.C: New file.
	* Makefile (COMPONENTS): Added.

	* weather_hourly.C: New file.
	* Makefile (COMPONENTS): Added.

	* weather_file.C (WeatherFile): Initialize `line'.

1998-03-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.015 released.

1998-03-28  Per Abrahamsen  <abraham@dina.kvl.dk>
	
	* biobioclimate.h, bioclimate_std.C, crop_std.C, crop_old.C,
	* crop_sold.C:
	(hourly_global_radiation) Renamed from `GlobalRadiation'.
	(daily_global_radiation) Renamed from `DailyRadiation'.
	(day_length): Renamed from `DayLength'.
	
	* bioclimate_std.C (WaterDistribution): Also use irrigation
	temperature. 

	* weather.C, weather.h, weather_simple.C, weather_none.C,
	* weather_file.C, action_irrigate.C, bioclimate_std.C
	(daily_air_temperature): Renamed from `AirTemperature'.
	(hourly_air_temperature): Added.
	(day_length): Renamed from `DayLength'.
	(day_cycle): Renamed from `DayCycle'.
	(rain): Renamed from `Rain'.
	(snow): Renamed from `Snow'.
	(cloudiness): Renamed from `Cloudiness'.
	(vapor_pressure): Renamed from `VaporPressure'.
	(wind): Renamed from `Wind'.
	
1998-03-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C, weather.h, weather_simple.C, weather_none.C,
	* weather_file.C, bioclimate_std.C:
	(hourly_global_radiation) Renamed from `GlobalRadiation'.
	(daily_global_radiation) Renamed from `DailyRadiation'.
	(Weather::hourly_global_radiation): Added.
	(WeatherFile::output): Removed.
	(WeatherFile::GlobalRadiation): Removed.
	(WeatherFile::A, WeatherFile::B): Removed.

	* weather_none.C (class WeatherNone::DailyRadiation): Don't
	multiply with 24.

1998-03-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.014 released.

	* common.h (BORLAND_PERMISSIONS): New flag.
	* log_table.C (LogTable::LogTable): Obey.
	* log_file.C (LogFile::print): Ditto.
	* printer_file.C (PrinterFile::Implementation::Implementation): Ditto.

	* printer_file.C (print_library_file): Remove bogus debug code.

1998-03-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cdaisy.C, cdaisy.h (daisy_alist_set_string_at): Don't uncomment.

	* cdaisy.C (daisy_alist_set_integer_at): Use `<=' instead of `<'.
	(daisy_alist_set_flag_at): Ditto.
	(daisy_alist_set_number_at): Ditto.
	(daisy_alist_set_string_at): Ditto.

	* daisy.h (syntax, alist): New members.
	* daisy.C, daisy.h (initialize): New function.
	(check): Remove `syntax' argument.
	* main.C (main): Update caller.
	* cdaisy.C, cdaisy.h (daisy_daisy_create): Call `Daisy::initialize'.
	New `syntax' argument. 
	(daisy_daisy_check): No `syntax' argument.

	* cmain.c (main): Update caller.
	* bugmain.c (main): Update caller.

1998-03-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop.h (CropList): Make it a deque.
	* column_std.C (tick): Rotate the queue in each tick.

	* crop.h, crop_std.C, crop_old.C, crop_sold.C (DM): New function. 
	* column_std.C, column.h (crop_dm): New function.
	* condition_crop.C (struct ConditionDMOver): New condition.

	* crop_std.C (DevelopmentStage): Only call `Vernalization' when
	required. 
	(CanopyPhotosynthesis): Replaces assertion with explict error message.
	(SoluteUptake): Always leave 1e-8.
	
	* Version 0.013 released.

	* Version 0.012 released.

	* log_table.C (struct LogEntry): Check "*" with path, not name.
	(struct LogTable): [CONST_DELETE] Don't delete members.

	* cdaisy.C (daisy_library_derive): Add "type" attribute.

	* weather.C (output): Log all data.
	(tick, DayLength, DayCycle): Move calculation of `day_length' and
	`day_cycle' to `tick'.
	* weather_simple.C (tick): Call `Weather::tick'.
	* weather_none.C (tick): Ditto.
	* weather_file.C (tick): Ditto.
	* bioclimate_std.C (tick): Don't pass time to `Weather::DayLength'.


1998-03-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (SOURCES, OBJECTS): Added `bugmain.c'.

	* printer_file.C (is_complex): Last item in a total order is never
	complex. 
	(struct FoundEntry): Renamed from `Entry' to avoid conflict with
	`log_table.C'. 

	* Version 0.011 released.

	* printer_file.C (PrinterFile): Delete `impl' after use.
	(print_library_file): Quote library member names if necessary.

1998-03-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C: New file.
	* Makefile (COMPONENTS): Add it.

	* log_file.C, log.h: Pass strings by reference.

	* log_file.C, log.h (open_unnamed): New function.
	(close_unnamed): New function.
	* log.h (output_vector): Use it.
	* log_file.C, log.h (open_derived): Renamed from `open'.
	(close_derived): New function.
	* log.h (output_derived): Use it.

	* syntax.C, syntax.h (total_order): New function.
	* parser_file.C (load_list): Use it.
	* printer_file.C (is_complex): Ditto.

	* log.C (done): New function.
	* daisy.C (tick_logs): Call it.

	* syntax.C (check): Handle missing alist sequence.
	* parser_file.C (load_list): Support string sequences.

	* frame.h (class Frame): No default parent.
	* log_file.C, log.h (match): Add `frame' parameter.
	* daisy.h (class Daisy): New `frame' member.
	* daisy.C (tick_logs): Use it.

1998-03-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.010 released.

	* column_std.C, column.h (crop_ds): New function.
	* crop.h (Crop): Make `DS' and `DSremove' public.
	* condition_crop.C: New file.
	* condition_soil.C: New file.

	* Version 0.009 released.

	* library.h (derive_function): New typedef.
	* library.C, library.h (Library): Add `derive' argument.
	(load_syntax): New function.
	* cdaisy.C (daisy_load): Call it.
	* main.C (main): Ditto.
	* tkmain.C (class TkDaisyState): Ditto.
	* daisy.C (load_syntax): Don't load library syntax here.
	* library.h (Implementation): Store it here.
	* librarian.h (class Librarian::Librarian): Pass `derive_type' to
	`Content'.
	(class Librarian::Content::Content): Pass `derive' to `Library'. 
	* am.C (AM_init): Pass `derive_type' to `Library'.
	* organic_matter.C (output): Use `AM::library' instead of creating
	a dummy library.
	* syntax.C, syntax.h (derive, derive_fun): Removed.
	(add_library): Don't take derive argument.
	* parser_file.C (load_list): Don't call `Syntax::derive'.
	* library.C, library.h (add_derived): New function.
	* parser_file.C (add_derived): Call it.
	* librarian.h (Librarian::add_library): Removed.

	* printer_file.C (PrinterFileSyntax): Add `PrinterFile' to
	`Printer' library.

	* Parser.C, parser.h: Use `Librarian' to manage.
	* parser_file.C, parser_file.h: Change derived.
	* daisy.C (load_syntax): Change callers.

	* printer.C: Don't include "alist.h".

1998-03-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* event.C: Removed warnings.

	* frame.C, frame.h (class Frame): New files.
	* Makefile (INTERFACES): Added them.
	* condition.C, condition.h: Use it.
	* action.C, action.h: Use it.  Convert to standard library.
	* minimanager.h, minimanager.C: Adjusted.
	* cdaisy.C (daisy_library_derive): Adjusted.
	(daisy_daisy_tick_action): Pass dummy `Frame' to `Action::doIt'.
	* log_file.C (match): Pass dummy `Frame' to `condition::match'.
	* action_fertilize.C, action_harvest.C, action_irrigate.C,
	* action_lisp.C, action_sow.C, action_stop.C, action_tillage.C,
	* action_with.C, condition_logic.C, condition_time.C: Adjusted
	derived objects.

	* condition_logic.C (class ConditionAnd): Fixed logic.

	* Version 0.008 released.

	* cdaisy.C, cdaisy.h (daisy_version): New function.

	* crop.C, crop.h: Use librarian to manage Crop.
	* crop_std.C, crop_old.C, crop_sold.C: Updated derived classes.
	* column_std.C, daisy.C, action_sow.C, event.C: Updated callers.

	* crop_std.C (CanopyStructure): Reverted previous change.  They
	already started at the ground.
	* bioclimate_std.C (RadiationDistribution): Enabled assertions.

1998-03-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 0.007 released.

	* parser_file.C (get_number, get_integer): Read one character a
	time in order to know the column number.

	* crop_std.C (CanopyStructure): Make LAIvsH start from the ground
	instead of the top.
	(CanopyPhotosynthesis): Adjust.
	* bioclimate_std.C (BioclimateStandard): Ditto.
	(RadiationDistribution): Ditto.

	* printer_file.C: Include <algorithm>.

1998-03-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C, weather.h (cloudiness, vaporpressure, wind): New
	functions. 

	* parser_file.C, parser_file.h (class ParserFile): Pass strings by
	reference.

	* crop_std.C (var.RootSys.nitrogen_stress): New log variable.
	(NetProduction): Use it.
	(par.Devel.defined_until_ds): New parameter.
	(CropHeight): Use it.
	(par.Canopy.rs_min, par.Canopy.rs_max): New parameters.

	* crop.C, crop.h, crop_std.C (water_stress, nitrogen_stress,
	rs_min, rs_max): New functions. 

	* lib/sbarley.dai: Fixed parameters.

	* lib/grass.dai: New file.
	* lib/wwheat.dai: New file.
	* lib/crop.dai: New file.
	* lib/Makefile (DAISY): Added.

1998-03-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate.C, bioclimate.h: Converted to library.
	* bioclimate_std.C: New file.
	* Makefile (COMPONENTS): Add it.
	* column_std.C: Update caller.
	* daisy.C (load_syntax): Add it.

	* Makefile (daisy-src.zip): Added `tlink32.ini'.

	* Version 0.006 released.

	* crop_std.C (CanopyPhotosynthesis): Added assertions.

	* csmp.C (integrate_stupidly): Add 10 extra intervals.

1998-03-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* filter.C, filter.h (check_derived): New function.
	(lookup_derived): New function.
	* log.h (output_derived): use them
	(output_list): Ditto, add library argument.
	* daisy.C (tick_logs): Ovey new calling convention.
	* organic_matter.C (output): Ditto.
	* column_std.C (output): Ditto.
	Filter names can now match superclasses as well.
	
	* filter.h, filter.C, filter_all.C, filter_array.C,
	filter_checkpoint.C, filter_none.C, filter_some.C: Pass strings
	per reference. 

	* cdaisy.C, cdaisy.h (daisy_alist_clone): New function.

	* crop_old.C (output): Don't checkpoint `LogPotCanopyAss' and
	`LogCanopyAss'.

	* crop_std.C: Added `enable_water_stress', 
	`enable_N_stress', `LogPotCanopyAss', and `LogCanopyAss'.

1998-03-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_file.C (output_point): Removed.
	(output (CSMP)): Don't call.  Use csmp directly instead.
	(class LogFile): Removed from interface.
	* log.h (class Log): Ditto.
	* csmp.C (output): Removed.
	* csmp.C: Removed unnecessary includes.
	* csmp.h: Ditto.

1998-03-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_old.C: (Parameters): Added `enable_water_stress' and
	`enable_N_stress'.
	(CropOldSyntax): Ditto.
	(tick): Obey `enable_water_stress'.
	(NetProduction): Obey `enable_N_stress'.
	(Variables): Added `LogPotCanopyAss' and `LogCanopyAss'.
	(output): Ditto.
	(RecCrpAux): Ditto.
	(CropOldSyntax): Ditto.
	(tick): Ditto.

	* crop_old.C: Removed compile time flag `USE_HOURLY_PHOTO'.

	* snow.C (tick): Use `approximate' to compare floating point
	values. 

	* cdaisy.h: Typo.

	* Version 0.005 released.

	* alist.C: Removed exception handling.

	* filter_some.C (lookup): Replace THROW with assert (false).
	* library.C (lookup): Ditto.
	(syntax): Ditto.

	* Version 0.004 released.

	* printer_file.C (print_comment): Support multiline comments.

	* printer.h (class Printer): Added `print_comment', `print_alist',
	`print_library_file', and `good' as pure virtual members.

	* cdaisy.C, cdaisy.h (daisy_alist_save): Deleted.
	(daisy_library_save_file): Ditto.
	(daisy_printer_create_file): New function.
	(daisy_printer_comment): Ditto.
	(daisy_printer_alist): Ditto.
	(daisy_printer_library_file): Ditto.
	(daisy_printer_delete): Ditto.
	(daisy_printer_good): Ditto.

1998-03-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (cvs): Add version to ChangeLog.
	(TEXT): Add `TODO' and `ChangeLog'.
	(wc): Only count sources.

	* solute.C (initialize): Initialize M from ppm and
	dry_bulk_density. 

	* horizon.C (dry_bulk_density): New function.
	* horizon.h: Ditto.
	* soil.h: Ditto.

	* Makefile: Removed DHI comments.

	* ChangeLog: New file.

